/**
 * Created by janis dähne.
 */


declare module 'react-notifications' {
  import * as React from "react";

  enum NotificationType {
    CHANGE = 'change',
    INFO = 'info',
    SUCCESS = 'success',
    WARNING = 'warning',
    ERROR = 'error'
  }

  export interface NotificationProps {
    readonly type: NotificationType

    readonly title?: string
    readonly message: string
    readonly timeOut?: number
    readonly callback?: () => void
    readonly priority?: boolean
  }

  export interface NotificationContainerProps {
    readonly enterTimeout?: number
    readonly leaveTimeout?: number
  }

  interface _NotificationContainer extends React.ComponentClass<NotificationContainerProps> {

  }

  interface _NotificationManager {
    readonly info: (message: string, title?: string, timeOut?: number, onClick?: () => void, priority?: boolean) => void
    readonly success: (message: string, title?: string, timeOut?: number, onClick?: () => void, priority?: boolean) => void
    readonly warning: (message: string, title?: string, timeOut?: number, onClick?: () => void, priority?: boolean) => void
    readonly error: (message: string, title?: string, timeOut?: number, onClick?: () => void, priority?: boolean) => void



  }

  export const NotificationManager: _NotificationManager
  export const NotificationContainer: _NotificationContainer

}
