# Yapex Frontend

# Dependencies

You have to install

* [NodeJS](https://nodejs.org/en/)
* [Yarn](https://classic.yarnpkg.com/en/docs/install#debian-stable)


## why yarn

we use yarn because npm (currently?) not allows to install **some** packages from github
e.g. https://github.com/janisdd/brace
error:

```bash
npm ERR! code ENOPACKAGEJSON
npm ERR! package.json Non-registry package missing package.json: git+https://github.com/janisdd/brace.git.
npm ERR! package.json npm can't find a package.json file in your current directory.
```


# Installation Guide for Debian 9 (Stretch)

Since you need to apply system-wide changes, you need to be root to proceed.

## Install nodejs

Although there is a module named `nodejs` in `apt`, *don't use it*. In fact, uninstall it via `apt remove nodejs`, if it's currently installed.

Why? Debian is a very stable Linux distribution. Every module is tested for an extended amount of time before it's released. That's why the modules in the package repositories often are … not the most recent version.

For running Yapex, you need a more recent version than the default package repository provides currently. (By now, it is version 8.x)

Take a look at [the NodeJS binary distribution github repository](https://github.com/nodesource/distributions/blob/master/README.md) and decide for a version. It should be at least version 8. (If you don't know, which one you need, take the most recent one.)

Following the installation guide: (Replace `<version>` by the number of the version you decided to install.)

```bash
curl -sL https://deb.nodesource.com/setup_<version>.x | bash -
apt-get install -y nodejs
```

To make sure the installation went right type `which nodejs`. If the answer in the terminal is a directory, it is installed. If you don't get any any answer, it isn't.

If you want to use the backend (ClientServer) as it is right now, you have to link `nodejs` to `node`: `ln -s /usr/bin/nodejs /usr/local/bin/node`.



## Install Yarn

First, the word `yarn` links to another package, `cmdtest`. It's a completely differenct package, in a different language, for a different purpose. It is *not* a replacement for Yarn. Make sure this one isn't installed! (For example with `apt remove cmdtest`. If you keep it there could be problematic interactions.)

You have to install the dependency `apt install apt-transport-https`. For unknown reasons, it isn't automatically installed while installing Yarn.

Following [the official guide](https://classic.yarnpkg.com/en/docs/install#debian-stable):

1. Adding the repository

```bash
curl -sS https://dl.yarnpkg.com/debian/pubkey.gpg | sudo apt-key add -
echo "deb https://dl.yarnpkg.com/debian/ stable main" | sudo tee /etc/apt/sources.list.d/yarn.list
```

2. Updating

This is important. If you skip this step, you won't be able to install Yarn. (cmdtest will pop up every time you try.)

```bash
apt update
```

3. Install

```bash
apt install yarn
```

Make sure your system doesn't try to install cmdtest. (Read before answering "Yes" to anything, you will be asked before a different package is installed.) If you don't get the right package, try to update, upgrade, and even restart the system, until you get what you need.



# Build (in Linux), tested for Debian 9 (Stretch)

You don't need to be root anymore. In fact, you shouldn't be.

Open a terminal within the cloned repository.

Run

```bash
yarn install
yarn run build
```


You find the files that are generated in `dist/`. (Those are going to be copied to `wwwroot/` in the ClientServer.) The folder `nocopy/` is for developement.


# Running dev server

if you added/removed some library make sure to run

```bash
npm run vendor
```

before so the files at `dist/nocopy` are updated

then to run the dev server run

```bash
npm run dev
```



## Adding a package

e.g. `yarn add react react-dom @types/react @types/react-dom`

after adding a package you need to rebuild the `vendor.dll.js` file
run `npm run vendor`


## Hints

- `fsevents` is needed on MacOS (at least for webpack@3.6 else the dev server will take 100% cpu watching files for changes
