/**
 * Created by janis dähne.
 */
import * as genericLayer from './genericLayer'
import {CustomProjectPreviewFullBase} from "../types/customProjects";
import {PaginatedData, PaginationPostData} from '../types/pagination'

const callingName = 'customProjectOverviewLayer'
const controllerPrefix = 'custom/projects/overview'

export async function getOwnCustomProjectOverviews(paginationPostData: PaginationPostData): Promise<PaginatedData<CustomProjectPreviewFullBase>> {
  return genericLayer.update<PaginationPostData, PaginatedData<CustomProjectPreviewFullBase>>(callingName,
    `${controllerPrefix}/all`,paginationPostData
  )
}

export async function deleteOwnCustomProject(customProjectPreview: CustomProjectPreviewFullBase): Promise<void> {
  return genericLayer.del<void>(callingName,
    `${controllerPrefix}/delete/${customProjectPreview.id}`)
}