/**
 * Created by janis dähne.
 */

import * as React from "react";
import {Button, ButtonProps} from "semantic-ui-react";
import {RootState} from "../../state/reducers";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from "react-redux-typescript";
import {connect} from "react-redux";
import {getI18n} from "../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState) => {
  return {
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
}, dispatch)

const stateProps = returntypeof(mapStateToProps)
const dispatchProps = returntypeof(mapDispatchToProps)
type Props = typeof stateProps & typeof dispatchProps

class CancelButton extends React.Component<Props & ButtonProps, any> {
  render(): JSX.Element {

    const {langId, ...otherProps} = this.props

    return (
      <div >
        <Button
          content={getI18n(langId, 'Cancel')}
          icon='cancel'
          labelPosition='left'
          {...otherProps}
        >
        </Button>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(CancelButton)
