/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers";

import SimpleAceEditor from './aceEditors/simpleAceEditor'
import {EditorTab} from "./multiTabCodeEditorProps";

//const css = require('./styles.styl');

export interface SimpleCodeEditorProps {
  //readonly test: string
  /**
   * a unique id for the editor
   */
  readonly id: string

  /**
   * the tab that should be displayed
   */
  readonly editorTab: EditorTab

  /**
   * called when the editor lost focus
   */
  readonly onBlur?: ((value: string, editorTabId: number) => void)

  /**
   * if set the onBlur will be called debounced with this value
   * cannot be changed after the component did mount!
   */
  readonly debounceTimeInMs?: number

  readonly height?: string

  readonly enableSpellcheck?: boolean
}

const mapStateToProps = (rootState: RootState, props: SimpleCodeEditorProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props
  }
}

//use this to quickly switch between monaco and ace editor
//BUT we only use ace now...
//BUT when we want to ever change the editor we only need it here!
//  because they use the same props everything (mostly) should be working...

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class simpleCodeEditorWrapper extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <SimpleAceEditor
        {...this.props}
      />
    )
  }
}

const _default = connect(mapStateToProps, mapDispatchToProps)(simpleCodeEditorWrapper)
export default _default
