/**
 * Created by janis dähne.
 */

import * as React from "react";
import {CSSProperties} from "react";
import {Icon, Popup, PopupProps, SemanticICONS} from "semantic-ui-react";
import {leftIconPopupOffset} from "../../constants";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly defaultText: string | JSX.Element

  /**
   * if you use additional text make sure
   * @see defaultText is also just a string
   */
  readonly additionalText?: string
  /**
   * the default icon is the question circle icon
   */
  readonly icon?: SemanticICONS

  /**
   * style will be applied to the icon
   */
  readonly style?: CSSProperties

  /**
   * class names are applied to the wrapping div
   */
  readonly className?: string
}

export const HelpPopup: React.SFC<MyProps & PopupProps> = (props) => {

  const {defaultText, icon, style, className, additionalText, ...popupProps} = props

  return (<div style={{display: 'inline-block'}} className={className}>
    <Popup
      trigger={<Icon className="hoverable" name={icon
                                                 ? icon as SemanticICONS
                                                 : 'question circle'} style={style}/>}
      content={!additionalText ? defaultText :
      <div>
        {
          defaultText
        }
        <br />
        <span style={{fontStyle: 'italic'}}>{additionalText}</span>
      </div>}
      horizontalOffset={leftIconPopupOffset}
      {...popupProps}
    />
  </div>)
}
