/**
 * Created by janis dähne.
 */

import * as React from "react";
import {CSSProperties} from "react";
import {Icon, Popup, PopupProps, SemanticICONS} from "semantic-ui-react";
import {leftIconPopupOffset} from "../../constants";

//const css = require('./styles.styl');

export interface MyProps {
  /**
   * class names are applied to the wrapping div
   */
  readonly className?: string
  readonly noHorizontalOffset?: boolean
}

/**
 * a custom popup with some default stylues
 * @param props
 * @constructor
 */
export const MyPopup: React.SFC<MyProps & PopupProps> = (props) => {

  const {className, noHorizontalOffset, content, trigger, ...popupProps} = props

  return (<Popup
    className={className}
    trigger={trigger}
    content={content}
    horizontalOffset={noHorizontalOffset ? 0 : leftIconPopupOffset}
    {...popupProps}
  />)
}
