/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers";
import {MyProps} from './renderWrapper'
import {escapeHtml, plainTextToHtmlPlainFilter} from "../../helpers/stringHelper";
import Logger from "../../helpers/logger";

//const css = require('./styles.styl');

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class textRenderer extends React.Component<Props, any> {

  //TODO move this to some helper

  render(): JSX.Element {

    Logger.debug("textRenderer", "rendering...")

    const content = {
      __html: plainTextToHtmlPlainFilter(this.props.content)
    }

    return (
      <div id={this.props.printId} className="fh full-w">
        <div dangerouslySetInnerHTML={content} style={{fontSize: this.props.fontSizeInPx}}>

        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(textRenderer)
