/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers";
import {Route, withRouter} from "react-router";
import * as constants from '../../constants'
import {Link} from "react-router-dom";
import {Icon} from "semantic-ui-react";
import {getI18n} from "../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    systemRole: rootState.userDataSettingsSate.userData
                && rootState.userDataSettingsSate.userData.systemRole
                ? rootState.userDataSettingsSate.userData.systemRole
                : null,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here

                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class RelatedLinksView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        {
          //-------- exercises stuff
        }
        <Route exact path={constants.openExercisesLinkPath} component={() =>
          <div className="related-links">
            <div>
              <Icon name="unlock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All open exercises')
                }
              </span>
            </div>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All closed exercises')
                }
              </span>
            </Link>
            <Link to={constants.ownExercisesLinkPath}>
              <Icon name="cube"/>
              <span>
                {
                  getI18n(this.props.langId, 'Own exercises')
                }
              </span>
            </Link>
            <Link to={constants.groupExercisesLinkPath}>
              <Icon name="cubes"/>
              <span>
                {
                  getI18n(this.props.langId, 'Group exercises')
                }
              </span>
            </Link>
            {
              (this.props.systemRole && this.props.systemRole.canManageTags) &&
              <Link to={constants.manageTagsLinkPath}>
                <Icon name="tags"/>
                <span>
                {
                  getI18n(this.props.langId, 'Manage Tags')
                }
              </span>
              </Link>
            }
          </div>
        }/>

        <Route exact path={constants.closedExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All open exercises')
                }
              </span>
            </Link>
            <div>
              <Icon name="lock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All closed exercises')
                }
              </span>
            </div>
            <Link to={constants.ownExercisesLinkPath}>
              <Icon name="cube"/>
              <span>
                {
                  getI18n(this.props.langId, 'Own exercises')
                }
              </span>
            </Link>
            <Link to={constants.groupExercisesLinkPath}>
              <Icon name="cubes"/>
              <span>
                {
                  getI18n(this.props.langId, 'Group exercises')
                }
              </span>
            </Link>
            {
              (this.props.systemRole && this.props.systemRole.canManageTags) &&
              <Link to={constants.manageTagsLinkPath}>
                <Icon name="tags"/>
                <span>
                {
                  getI18n(this.props.langId, 'Manage Tags')
                }
              </span>
              </Link>
            }
          </div>
        }/>


        <Route exact path={constants.ownExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All open exercises')
                }
              </span>
            </Link>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All closed exercises')
                }
              </span>
            </Link>
            <div>
              <Icon name="cube"/>
              <span>
                {
                  getI18n(this.props.langId, 'Own exercises')
                }
              </span>
            </div>
            <Link to={constants.groupExercisesLinkPath}>
              <Icon name="cubes"/>
              <span>
                {
                  getI18n(this.props.langId, 'Group exercises')
                }
              </span>
            </Link>
            {
              (this.props.systemRole && this.props.systemRole.canManageTags) &&
              <Link to={constants.manageTagsLinkPath}>
                <Icon name="tags"/>
                <span>
                {
                  getI18n(this.props.langId, 'Manage Tags')
                }
              </span>
              </Link>
            }
          </div>
        }/>

        <Route exact path={constants.groupExercisesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All open exercises')
                }
              </span>
            </Link>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All closed exercises')
                }
              </span>
            </Link>
            <Link to={constants.ownExercisesLinkPath}>
              <Icon name="cube"/>
              <span>
                {
                  getI18n(this.props.langId, 'Own exercises')
                }
              </span>
            </Link>
            <div>
              <Icon name="cubes"/>
              <span>
                {
                  getI18n(this.props.langId, 'Group exercises')
                }
              </span>
            </div>
            {
              (this.props.systemRole && this.props.systemRole.canManageTags) &&
              <Link to={constants.manageTagsLinkPath}>
                <Icon name="tags"/>
                <span>
                {
                  getI18n(this.props.langId, 'Manage Tags')
                }
              </span>
              </Link>
            }
          </div>
        }/>

        <Route exact path={constants.manageTagsLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.openExercisesLinkPath}>
              <Icon name="unlock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All open exercises')
                }
              </span>
            </Link>
            <Link to={constants.closedExercisesLinkPath}>
              <Icon name="lock"/>
              <span>
                {
                  getI18n(this.props.langId, 'All closed exercises')
                }
              </span>
            </Link>
            <Link to={constants.ownExercisesLinkPath}>
              <Icon name="cube"/>
              <span>
                {
                  getI18n(this.props.langId, 'Own exercises')
                }
              </span>
            </Link>
            <Link to={constants.groupExercisesLinkPath}>
              <Icon name="cubes"/>
              <span>
                {
                  getI18n(this.props.langId, 'Group exercises')
                }
              </span>
            </Link>
            {
              (this.props.systemRole && this.props.systemRole.canManageTags) &&
              <div>
                <Icon name="tags"/>
                <span>
                {
                  getI18n(this.props.langId, 'Manage Tags')
                }
              </span>
              </div>
            }
          </div>
        }/>

        {
          //-------- groups stuff
        }
        <Route exact path={constants.groupsLinkPath} component={() =>
          <div className="related-links">
            <div>
              <span>
                {
                  getI18n(this.props.langId, 'Groups')
                }
              </span>
            </div>

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.groupRolesLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Group roles')
                }
              </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.groupRolesLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.groupsLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Groups')
                }
              </span>
            </Link>
            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <div>
                <span>
                  {
                    getI18n(this.props.langId, 'Group roles')
                  }
                </span>
              </div>
            }

          </div>
        }/>
        <Route exact path={constants.singleGroupLinkPath} component={() =>
          <div className="related-links">
            <Link to={constants.groupsLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Groups')
                }
              </span>
            </Link>
            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.groupRolesLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Group roles')
                }
              </span>
              </Link>
            }

          </div>
        }/>


        {
          //-------- system & user
        }

        <Route exact path={constants.manageNewUsersLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <div>
                <span>
                  {
                    getI18n(this.props.langId, 'Manage new users')
                  }
                </span>
              </div>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                  || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <Link to={constants.manageActivatedUsersLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Manage activated users')
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.systemRolesLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'System roles')
                }
              </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.manageActivatedUsersLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <Link to={constants.manageNewUsersLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Manage new users')
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                  || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <div>
              <span>
                {
                  getI18n(this.props.langId, 'Manage activated users')
                }
              </span>
              </div>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <Link to={constants.systemRolesLinkPath}>
                <span>
                  {
                    getI18n(this.props.langId, 'System roles')
                  }
                </span>
              </Link>
            }

          </div>
        }/>

        <Route exact path={constants.systemRolesLinkPath} component={() =>
          <div className="related-links">
            {
              (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
              <Link to={constants.manageNewUsersLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Manage new users')
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole && (this.props.systemRole.canChangeUserData
                  || this.props.systemRole.canDeleteActivatedUsers)
              ) &&
              <Link to={constants.manageActivatedUsersLinkPath}>
              <span>
                {
                  getI18n(this.props.langId, 'Manage activated users')
                }
              </span>
              </Link>
            }

            {
              (this.props.systemRole &&
                (this.props.systemRole.canCreateRoles
                  || this.props.systemRole.canChangeRoles
                  || this.props.systemRole.canDeleteRoles)
              ) &&
              <div>
                <span>
                  {
                    getI18n(this.props.langId, 'System roles')
                  }
                </span>
              </div>
            }

          </div>
        }/>


      </div>
    )
  }
}

export default withRouter(connect(mapStateToProps, mapDispatchToProps)(RelatedLinksView))