import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import Spinner from "../../helpers/spinner";
import {getI18n} from "../../../../i18n/i18nRoot";
import {AnySettingsTable} from './anySettingsTable'
import {HelpPopup} from '../../helpers/helpPopup'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    clientServerAppSettings: rootState.dashboardSiteState.clientServerAppSettings,
    isLoading: rootState.dashboardSiteState.isLoading,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here

                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


class serverSystemSettingsView extends React.Component<Props, any> {
  render(): JSX.Element {

    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }


        <div className="view-padding">

          <div className="view-head-line">

            <div className="view-caption">
              <h2>
                {
                  getI18n(this.props.langId, 'Server app settings')
                }
              </h2>
              <HelpPopup className="mar-left-half" style={{marginTop: '0.6em'}} wide defaultText={getI18n(this.props.langId, "These settings are the app settings and can be overwritten in appsettings.json file. These are fixed after the server process is started.")}/>
            </div>

            <div className="view-options">

            </div>
          </div>

          <div className="view-content">

            <AnySettingsTable langId={this.props.langId} listObj={this.props.clientServerAppSettings} />

          </div>
        </div>


      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(serverSystemSettingsView)
