/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Table} from "semantic-ui-react";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import Spinner from "../../helpers/spinner";
import {getI18n, LangObj} from "../../../../i18n/i18nRoot";
import {AnySettingsTable} from './anySettingsTable'
import {HelpPopup} from '../../helpers/helpPopup'
import {TestServerPrivateSettings} from '../../../types/dashboard'

//const css = require('./styles.styl');

export interface MyProps {
  readonly title: keyof  LangObj
  readonly testServerSettings: TestServerPrivateSettings | null
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props,
    isLoading: rootState.dashboardSiteState.isLoading,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

interface Pair {
  readonly property: string
  readonly value: string
}


class logicalUsageView extends React.Component<Props, any> {
  render(): JSX.Element {

    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }


        <div className="view-padding">

          <div className="view-head-line">

            <div className="view-caption">
              <h2>
                {
                 getI18n(this.props.langId,this.props.title)
                }
              </h2>
            </div>

            <div className="view-options">

            </div>
          </div>

          <div className="view-content">

            <AnySettingsTable langId={this.props.langId} listObj={this.props.testServerSettings}/>

          </div>
        </div>

      </SinglePanelSiteWrapper>
    )

  }
}

export default connect(mapStateToProps, mapDispatchToProps)(logicalUsageView)
