/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers";
import {getI18n} from "../../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    assessmentResult: rootState.doExerciseSiteState.assessmentResult,
    release: rootState.doExerciseSiteState.exercise.exerciseRelease,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here

                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class assessmentResultPanelHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">
        <div className="mar-right-half">
          {
            getI18n(this.props.langId, 'Manual points')
          }
          :
        </div>
        <div>
          {
            this.props.assessmentResult.manualPoints !== null
            ? this.props.assessmentResult.manualPoints.toString()
            : getI18n(this.props.langId,
                      'No manual points set'
            )
          }
          {
            this.props.release.maxManualPoints !== null &&
            <span>
              {
                ` / ${this.props.release.maxManualPoints}`
              }
            </span>
          }
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(assessmentResultPanelHeaderBar)
