import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from '../../../../../state/reducers'
import {getI18n} from '../../../../../../i18n/i18nRoot'
import {Header, Modal} from 'semantic-ui-react'
import ChoosePLangView from './choosePLangView'
import ChoosePLangActions from './choosePLangActions'

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here
                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


class ChoosePLangModal extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        {/*not really hosted here, this is created in an outer most div */}
        <Modal open={true}>
          <Header>
            {
              getI18n(this.props.langId, 'Programming language for custom project')
            }
          </Header>

          <Modal.Content>

            <ChoosePLangView/>

          </Modal.Content>

          <Modal.Actions>

            {
              //make a new control because the ok button should be disabled when the default option is selected
              //the change would rerender this component if we use rootState.editCustomProjectSiteState.customProject.solution.pLangId
              //here which causes flickering on safari (when selecting a value)
            }
            <ChoosePLangActions/>

          </Modal.Actions>

        </Modal>


      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChoosePLangModal)
