import * as React from "react";
import {SyntheticEvent} from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from '../../../../../state/reducers'
import {getI18n} from '../../../../../../i18n/i18nRoot'
import MaterialSelectWrapper from '../../../../material/materialSelectWrapper'
import {Button, Divider, Form, Header, Modal, Segment} from 'semantic-ui-react'
import CancelButton from '../../../../buttons/cancelButton'
import {
  setInitialPLangId,
  setIsChoosePLangDialogDisplayed
} from '../../../../../state/actions/editCustomProjectSite/editCustomProjectActions'
import history from '../../../../../routerHistory'
import * as constants from '../../../../../constants'

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    customProject: rootState.editCustomProjectSiteState.customProject,

    pLangs: rootState.pLangsState.pLangs,

    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here
                                                                        setIsChoosePLangDialogDisplayed,
                                                                        setInitialPLangId,
                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


class ChoosePLangDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="ui form">

        <Form.Field>
          <MaterialSelectWrapper
            value={this.props.customProject.solution.pLangId}
          >
            <select
              value={this.props.customProject.solution.pLangId}
              onChange={(e: SyntheticEvent<HTMLSelectElement>) => {
                const plangId = parseInt(e.currentTarget.value)

                if (isNaN(plangId) || plangId < 0) {
                  return
                }

                this.props.setInitialPLangId(plangId)
              }}
            >
              <option key={-1} value={-1}>
                {
                  getI18n(this.props.langId, "Select an option...")
                }
              </option>
              {
                this.props.pLangs.map((plang, index) => {
                  return (
                    <option key={plang.id} value={plang.id}>
                      {
                        plang.displayName
                      }
                    </option>
                  )
                })
              }

            </select>
          </MaterialSelectWrapper>
        </Form.Field>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ChoosePLangDialog)
