/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers";
import ChangeTestView, {changeTestViewEditorId} from './changeTestView'
import {
  applyChangedEditorTestDialog,
  cancelEditorTestDialog
} from "../../../../../state/actions/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogActions";
import FullSiteDialog from '../../../../fullSiteDialog'


import {getI18n} from "../../../../../../i18n/i18nRoot";
import {AceEditorsStorageHelper} from "../../../../codeEditors/aceEditors/aceEditorsStorageHelper";
import TestServerHints from '../../../../helpers/testing/testServerHints'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isBusy: rootState.changeTestDialogState.isBusy || rootState.testTypesState.isLoading,
    isCreating: rootState.changeTestDialogState.isCreating,
    isValid: rootState.changeTestDialogState.isValid,
    test: rootState.changeTestDialogState.test,
    allTests: rootState.exerciseEditorState.editorExercise.tests,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  cancelEditorTestDialog,
  applyChangedEditorTestDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeTestDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
        <FullSiteDialog
          isBusy={this.props.isBusy}
          isValid={this.props.isValid}
          caption={
            <div className="flexed">
              <h2 className="mar-right">
                {
                  this.props.isCreating &&
                  (this.props.test.isSubmitTest ? getI18n(this.props.langId,'Create submit test') : getI18n(this.props.langId,'Create normal test'))
                }
                {
                  !this.props.isCreating &&
                  (this.props.test.isSubmitTest ? getI18n(this.props.langId,'Change submit test') : getI18n(this.props.langId,'Change normal test'))
                }
              </h2>

              <TestServerHints/>

            </div>
          }
          onSave={() => {
            this.props.applyChangedEditorTestDialog(this.props.test, this.props.isCreating, this.props.allTests)
            AceEditorsStorageHelper.removeEditor(changeTestViewEditorId)
          }}
          onCancel={() => {
            this.props.cancelEditorTestDialog()
            AceEditorsStorageHelper.removeEditor(changeTestViewEditorId)
          }}
        >
          <ChangeTestView/>
        </FullSiteDialog>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeTestDialog)
