/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {FormattedMessage} from 'react-intl';
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import HomeSiteCard from './homeSiteCard'
import * as constants from "../../../constants";


import {getI18n} from "../../../../i18n/i18nRoot";


//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HomeSite extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        <div className="home-site-card-list">

          {
            /*
            <HomeSiteCard icon="home" caption="Home" link={constants.homeLinkPath}
                        description={
            'Die Startseite bietet eine kleine Übersicht über alle wichtigen Funkionen (diese Seite).'
          }/>
             */
          }

          <HomeSiteCard icon="unlock" isRealLink={false} caption={getI18n(this.props.langId,'All open exercises')}
                        link={constants.openExercisesLinkPath}
                        description={
                          getI18n(this.props.langId,'On this site all open exercises are displayed (that can be solved).')
                        }/>


          <HomeSiteCard icon="cube" cornerIconInverted isRealLink={false}
                        caption={getI18n(this.props.langId,'Own exercises')} link={constants.ownExercisesLinkPath}
                        description={
                          getI18n(this.props.langId,'On this site all your exercises are displayed (where you are the owner).')
                        }/>


          <HomeSiteCard icon="cubes"  cornerIconInverted isRealLink={false}
                        caption={getI18n(this.props.langId,'Group exercises')} link={constants.groupExercisesLinkPath}
                        description={
                          getI18n(this.props.langId,'On this site all exercises of groups are displayed where you are a member.')
                        }/>

          <HomeSiteCard icon="area chart" isRealLink={false}
                        caption={getI18n(this.props.langId,'My assessment statistic')} link={constants.assessmentStatisticsSiteToLinkPath}
                        description={
                          getI18n(this.props.langId,'An overview what exercise you have started and how much points you got.')
                        }/>

          <HomeSiteCard icon="book" isRealLink={true}
                        caption={getI18n(this.props.langId,'Documentation')} link={constants.documentationForUsersLink}
                        description={
                          getI18n(this.props.langId,'The link to the documentation for all users.')
                        }/>


        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HomeSite)
