/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {deleteMultipleActivatedUserAsync} from "../../../state/actions/manageActivatedUsersSite/manageActivatedUsersSiteCrudActions";


import {getI18n} from "../../../../i18n/i18nRoot";
import {askDialog} from '../../../helpers/dialogHelper'


//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageActivatedUsersState.isLoading,
    activatedUsers: rootState.manageActivatedUsersState.activatedUsers,

    isSomeDialogDisplay: rootState.manageActivatedUsersState.isChangeUserDataDialogDisplayed,

    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
  //imported reducer funcs here
  deleteMultipleActivatedUserAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBar extends React.Component<Props, any> {


  render(): JSX.Element {

    const isSomeUserSelected = this.props.activatedUsers.some(p => p.uiIsSelected)

    const leftArea = (
      <div>
        {
          (this.props.systemRole && this.props.systemRole.canDeleteActivatedUsers) &&
          <div className={isSomeUserSelected ? 'clickable' : 'div-disabled'}
               onClick={async () => {

                 const shouldDelete = await askDialog(getI18n(this.props.langId, "Delete activated user"), getI18n(this.props.langId, "Are you sure you want to delete the activated user?"), this.props.langId)

                 if (!shouldDelete) return

                 this.props.deleteMultipleActivatedUserAsync(
                   this.props.activatedUsers.filter(p => p.uiIsSelected)
                 )
               }}
          >
            <Icon name="remove"/>
            <span>
            {
              getI18n(this.props.langId,'Delete selected users')
            }
          </span>
          </div>
        }


      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading || this.props.isSomeDialogDisplay}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBar)