/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../helpers/simpleVDivider";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {Link} from "react-router-dom";
import * as constants from '../../../constants'
import {deleteMultipleActivatedUserAsync} from "../../../state/actions/manageActivatedUsersSite/manageActivatedUsersSiteCrudActions";


import {getI18n} from "../../../../i18n/i18nRoot";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {

    isLoading: rootState.manageCustomProjectsSiteState.isLoading
      || rootState.systemSettingsSiteState.isLoading
      || rootState.pLangsState.isLoading
      || rootState.globalSystemSettingsState.isLoading,

    canCreateCustomProjects: rootState.manageCustomProjectsSiteState.customProjectPreviews.length < rootState.globalSystemSettingsState.systemSettings.maxCustomProjectsPerUser || rootState.globalSystemSettingsState.systemSettings.maxCustomProjectsPerUser < 0,

    systemSettings: rootState.globalSystemSettingsState.systemSettings,
    customProjectPreviews: rootState.manageCustomProjectsSiteState.customProjectPreviews,
    langId: rootState.i18nState.langId
  }
}

const mapDispatchToProps = (dispatch: Dispatch) => bindActionCreators({
                                                                        //imported reducer funcs here
                                                                        deleteMultipleActivatedUserAsync
                                                                      }, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBar extends React.Component<Props, any> {


  render(): JSX.Element {

    const leftArea = (
      <div className="flexed">

        {
          this.props.canCreateCustomProjects &&
          <div>
            <Link to={constants.createCustomProjectSiteToLinkPath}>
              <Icon name="add"/>
              <span>
            {
              getI18n(this.props.langId, 'Create custom project')
            }
          </span>
            </Link>
          </div>
        }
        {
          this.props.canCreateCustomProjects &&
          <SimpleVDivider/>
        }

        <div>
          {
            `${this.props.systemSettings.maxCustomProjectsPerUser < 0
               ? getI18n(this.props.langId, "unlimited")
               : this.props.systemSettings.maxCustomProjectsPerUser - this.props.customProjectPreviews.length} ${getI18n(
              this.props.langId,
              'project(s) left'
            )}`
          }
        </div>

      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBar)
