/**
 * Created by janis dähne.
 */

declare var require: any
const crypto = require('crypto-js')


/**
 * returns a hashed password
 * @param pw the pw to hash
 * @returns {any} the hashed pw
 */
export function hash(pw: string): string {

  if (!crypto) {
    throw new Error('no cryptojs found !')
  }

  return crypto.SHA512(pw).toString(crypto.enc.Hex)
}

export function hashBase64(pw: string): string {

  if (!crypto) {
    throw new Error('no cryptojs found !')
  }

  return crypto.SHA256(pw).toString(crypto.enc.Base64)
}
