/**
 * Created by janis dähne.
 */


export class LoginTimeoutHelper {
  // noinspection TsLint
  /**
   * true: reload site after log in
   * false: if login is displayed and it's not the first login then some sites don't need to full reload
   * (e.g. sits with editors)
   * e.g. edit exercise when creating an exercise all would be gone because create exercise first resets all
   * @type {boolean}
   */
  static isReLogin = false

  /**
   * only set to false after first login
   * @type {boolean}
   */
  static isFirstLogin = true

  /**
   * stores the last known user id to know if the same user logged in or not
   * @type {number}
   */
  static lastKnownUserId = -1

  /**
   * used to know if we need to reload the do exercise site or if the user just re logged in
   * @type {string}
   */
  static lastKnownDoEditorReleaseCode = ''

  /**
   * used to know if we need to reload the exercise editor site or if the user just re logged in
   * @type {number}
   */
  static lastKnownExerciseEditorId = -1


  /**
   * used to know if we need to reload the tutor assess site or if the user just re logged in
   * concat releaseId, userId, pLangId with - to get a unique id
   */
  static lastKnownTutorAssessmentId = ''


  static lastKnownCustomProjectId = -1

}