/**
 * Created by janis dähne.
 */


/**
 * gets the max with the map func
 *
 *
 * @param {ReadonlyArray<T>} array
 * @param {(el: T) => number} mapFunc
 * @returns {number} the max or null (if array was empty or falsy)
 */
export function getMax<T>(array: ReadonlyArray<T>, mapFunc: (el: T) => number): number | null {

  if (!array || array.length === 0) return null

  const nums = array.map(mapFunc)

  //this is slow but only 1 line...
  //https://stackoverflow.com/questions/1669190/find-the-min-max-element-of-an-array-in-javascript
  const max = Math.max.apply(Math, nums)

  return max

}

export function getMaxEntity<T>(array: ReadonlyArray<T>, mapFunc: (el: T) => number): T | null {

  if (!array || array.length === 0) return null

  // noinspection TsLint
  let max: number = null
  // noinspection TsLint
  let currMaxEntity: T = null

  // noinspection TsLint
  for(let i = 0; i < array.length;i++) {
    const val = mapFunc(array[i])

    if (max === null || val > max) {
      currMaxEntity = array[i]
    }
  }

  return currMaxEntity
}

export function getMinEntity<T>(array: ReadonlyArray<T>, mapFunc: (el: T) => number): T | null {

  if (!array || array.length === 0) return null

  // noinspection TsLint
  let min: number = null
  // noinspection TsLint
  let currMinEntity: T = null

  // noinspection TsLint
  for(let i = 0; i < array.length;i++) {
    const val = mapFunc(array[i])

    if (min === null || val < min) {
      currMinEntity = array[i]
    }
  }

  return currMinEntity
}