/**
 * Created by janis dähne.
 */


export function startsWith(str1: string, toCheck: string): boolean {
  return str1.substring(0, toCheck.length) === toCheck
}


//from http://stackoverflow.com/questions/2998784/how-to-output-integers-with-leading-zeros-in-javascript

/**
 * converts the number to a string and adds 0 left until we have num places
 * @param {number} num the number to pad
 * @param placed the amount of places to use (e.g. 2 --> xx)
 * @param padChar
 * @returns {string}
 */
export function padLeft(num: number, placed: number, padChar = '0'): string {

  // noinspection TsLint
  let s = num + "";
  while (s.length < placed) s = padChar + s;
  return s;

  //return ("0" + num).slice(-2)
}


//from marked
export function escapeHtml(html: string, encode?: boolean): string {
  return html
    .replace(!encode ? /&(?!#?\w+;)/g : /&/g, '&amp;')
    .replace(/</g, '&lt;')
    .replace(/>/g, '&gt;')
    .replace(/"/g, '&quot;')
    .replace(/'/g, '&#39;');
}


/**
 * inserts line numbers (with space) before every line
 * @param {string} code (multi) line string
 * @param spaceAfterNumber the space (string) to insert after every number (between the line number part and the code part)
 * @returns {string}
 */
export function insertLineNumbers(code: string, spaceAfterNumber = ' '): string {
  // noinspection TsLint
  let lineNumber = 0;
  const lines = code.split('\n')
  const neededPlaces = lines.length.toString().length //if we have 100 lines we need 3 places... (10 --> 2)
  const linesWithNumbers = lines.map<string>(p => {
    return padLeft(++lineNumber, neededPlaces, ' ') + spaceAfterNumber + p
  })

  return linesWithNumbers.join("\n")
}

/**
 * converts the plain text to html
 * replaces new lines with brs
 * escapes html
 * @param text
 */
export function plainTextToHtmlPlainFilter(text:string):string {

  //escape
  // noinspection TsLint
  let temp = text
  temp = escapeHtml(temp)
  temp = temp.split('\n').join('<br />')
  return temp
}