/**
 * Created by janis dähne.
 */
import {SortDirection} from "../types/sortDirection";
import {
  EditableExercisePreviewFromBackend, ExercisePreviewFromBackend,
} from "../types/exercisePreview";
import {orderBy} from 'lodash-es'


export function isCurrentSortingColumnPaginated<T>(sortByKeyProp: keyof T |null, columnName: keyof T,
                                                   sortDirection: boolean | null
): 'ascending' | 'descending' | null {

  if (sortByKeyProp === null) return null

  if ((sortByKeyProp as string).toLowerCase() !== (columnName as string).toLowerCase()) return null

  if (sortDirection === false) return 'ascending'

  if (sortDirection === true) return 'descending'

  return null
}

export function rotateSorting<T>(sortDirection: boolean | null, beforeColumn: keyof T,
                                 afterColumn: keyof T
): boolean | null {

  if ((beforeColumn as string).toLowerCase() !== (afterColumn as string).toLowerCase()) {
    return true //new column we start desc
  }

  if (sortDirection === false) { //curr = ascending
    return null
  }
  if (sortDirection === true) { //curr = descending
    return false
  }

  return true //curr = not sorted --> desc
}
