/**
 * Created by janis dähne.
 */
import createHashHistory from "history/createHashHistory";
import {Action, Location} from "history";

import {setLastKnownUrl} from './state/actions/browserHistoryActions'
import state from './state/state'
import Logger from './helpers/logger'
import {clearCloseWindowEvent} from "./helpers/eventsHelper";

/**
 * if we switch to another router
 * @see ReleaseCodeBigView.getLink change to get a valid link
 */
const history = createHashHistory()

history.listen((location: Location, action: Action) => {
  state.dispatch(setLastKnownUrl(location.pathname.toString()))
  //for some exam this should be no problem because we get a link directly to the exercise (so no navigation)
  //and the exam browser normally does not display the url
  Logger.log(`navigating to ${location.pathname.toString()}`)
  //in case some comp missed to remove this events...
  clearCloseWindowEvent()
})

export default history
