/**
 * Created by janis dähne.
 */
import {
  ActionType, ResetAction,
  SET_runnableTestAction
} from "../../../../reducers/doExerciseSite/dialogs/viewTestDialog/viewTestDialogReducer";
import {RunnableExerciseTestFrontendExclusive} from "../../../../../types/exerciseEditor";
import {RunnableCustomTestFrontendExclusive} from "../../../../../types/customTests";
import {MultiActions} from "../../../types";
import {setIsViewTestDialogDisplayed} from "../../doExerciseSiteActions";
import {AssessedSubmitTestFromBackend, AssessedSubmitTestFrontendExclusive} from "../../../../../types/testResults";


export function openViewTestDialog(runnableTest: RunnableExerciseTestFrontendExclusive | AssessedSubmitTestFrontendExclusive | null): MultiActions {
  return dispatch => {

    dispatch(resetViewTestDialog())
    dispatch(setViewTest(runnableTest))
    dispatch(setIsViewTestDialogDisplayed(true))

  }
}

export function cancelViewTestDialog(): MultiActions {
  return dispatch => {

    dispatch(resetViewTestDialog())
    dispatch(setIsViewTestDialogDisplayed(false))

  }
}

export function setViewTest(runnableTest: RunnableExerciseTestFrontendExclusive | AssessedSubmitTestFrontendExclusive | null): SET_runnableTestAction {
  return {
    type: ActionType.SET_runnableTest,
    runnableTest
  }
}

export function resetViewTestDialog(): ResetAction {
  return {
    type: ActionType.RESET
  }
}