import {
  ActionType, SET_hideErrorOutputLinesAction, SET_hideExpectedOutputLinesAction,
  SET_quickCodeEditorFontSizeInPxAction,
  SET_taskDescriptionFontSizeInPxAction, SET_useDiffIfOutputMismatchedAction, SET_useReplaceWhiteSpacesWithBulletsAction
} from '../reducers/globalUiReducer'


export function setGlobalTaskDescriptionFontSizeInPx(taskDescriptionFontSizeInPx: number): SET_taskDescriptionFontSizeInPxAction {
  return {
    type: ActionType.SET_taskDescriptionFontSizeInPx,
    taskDescriptionFontSizeInPx
  }
}


export function setQuickCodeEditorFontSizeInPx(quickCodeEditorFontSizeInPx: number | null): SET_quickCodeEditorFontSizeInPxAction {
  return {
    type: ActionType.SET_quickCodeEditorFontSizeInPx,
    quickCodeEditorFontSizeInPx
  }
}

//--- console view options

export function setUseDiffIfOutputMismatched(useDiffIfOutputMismatched: boolean): SET_useDiffIfOutputMismatchedAction {
  return {
    type: ActionType.SET_useDiffIfOutputMismatched,
    useDiffIfOutputMismatched
  }
}


export function setUseReplaceWhiteSpacesWithBullets(useReplaceWhiteSpacesWithBullets: boolean): SET_useReplaceWhiteSpacesWithBulletsAction {
  return {
    type: ActionType.SET_useReplaceWhiteSpacesWithBullets,
    useReplaceWhiteSpacesWithBullets
  }
}

export function setHideExpectedOutputLines(hideExpectedOutputLines: boolean): SET_hideExpectedOutputLinesAction {
  return {
    type: ActionType.SET_hideExpectedOutputLines,
    hideExpectedOutputLines
  }
}

export function setHideErrorOutputLines(hideErrorOutputLines: boolean): SET_hideErrorOutputLinesAction {
  return {
    type: ActionType.SET_hideErrorOutputLines,
    hideErrorOutputLines
  }
}



