/**
 * Created by janis dähne.
 */
import {UserGroupBase} from "../../../../types/group";
import {AwaitActions} from "../../types";
import {getGroupsAsync} from "../groupsCrudActions";
import {setIsChangeDialogDisplayed} from "../groupsSiteActions";
import {resetChangeGroupDialog} from "./changeGroupDialogActions";
import {ActionType} from "../../../reducers/groupsSite/dialog/actionTypes";
import {UPDATE_groupAction} from "../../../reducers/groupsSite/dialog/updateGroupReducer";
import {CREATE_groupAction} from "../../../reducers/groupsSite/dialog/createGroupReducer";

import {delay} from "../../../../../debug";
import {create, deleteUserGroup, update} from "../../../../communicationLayer/groupsLayer";
import {DELETE_groupAction} from "../../../reducers/groupsSite/dialog/deleteGroupReducer";
import {getAllPaginationItemsPostData} from '../../../../constants'


export function createGroupAsync(group: UserGroupBase): AwaitActions {
  return async (dispatch) => {

    await dispatch(_createGroupAsync(group))
    dispatch(getGroupsAsync(null))
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeGroupDialog())
  }
}

function _createGroupAsync(group: UserGroupBase): CREATE_groupAction {
  return {
    type: ActionType.CREATE_group,
    payload: delay(create(group))
  }
}

export function updateGroupAsync(group: UserGroupBase): AwaitActions {
  return async (dispatch) => {


    await dispatch(_updateGroupAsync(group))
    dispatch(getGroupsAsync(null))
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeGroupDialog())
  }
}

function _updateGroupAsync(group: UserGroupBase): UPDATE_groupAction {
  return {
    type: ActionType.UPDATE_group,
    payload: delay(update(group))
  }
}


export function deleteGroupAsync(groupId: number): AwaitActions {
  return async (dispatch) => {
    await dispatch(_deleteGroupAsync(groupId))
    await dispatch(getGroupsAsync(null))
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeGroupDialog())
  }
}

function _deleteGroupAsync(groupId: number): DELETE_groupAction {
  return {
    type: ActionType.DELETE_group,
    payload: delay(deleteUserGroup(groupId))
  }
}
