/**
 * Created by janis dähne.
 */
import {AwaitActions} from "../../types";
import {BaseUserData, IdAndPasswordTuple, SystemRoleFullBase} from "../../../../types/userData";
import {ActionType} from "../../../reducers/manageActivatedUsersSite/dialog/changeActivatedUserDataDialogActionTypes";
import {delay} from "../../../../../debug";
import {UPDATE_activatedUserDataAction} from "../../../reducers/manageActivatedUsersSite/dialog/updateActivatedUserDataReducer";
import {setIsChangeUserDataDialogDisplayed} from "../manageActivatedUsersSiteActions";
import {adminUpdateUserData, changeUsersSystemRole, resetPassword} from "../../../../communicationLayer/usersLayer";
import {UPDATE_activatedUserSystemRoleDataAction} from "../../../reducers/manageActivatedUsersSite/dialog/updateActivatedUserSystemRoleReducer";
import {UserSystemRoleTupleForBackend} from "../../../../types/users";
import {resetChangeActivatedUserDataDialog} from "./changeActivatedUserDataDialogActions";
import {getActivatedUsersAsync} from "../manageActivatedUsersSiteCrudActions";
import {RESET_activateUserPasswordAction} from "../../../reducers/manageActivatedUsersSite/dialog/resetActivatedUserPasswordReducer";
import {PaginationHelper} from '../../../../helpers/paginationHelper'


export function updateActivatedUserDataAsync(userData: BaseUserData, systemRole: SystemRoleFullBase): AwaitActions {
  return async (dispatch, getState) => {

    await dispatch(_updateActivatedUserDataAsync(userData))
    await dispatch(_updateActivatedUserSystemRoleAsync({
      userId: userData.targetUserId,
      systemRoleId: (systemRole && systemRole.id > 0 ? systemRole.id : null)
    }))

    const systemRoles = getState().manageActivatedUsersState.systemRoles
    const currentUserId = getState().userDataSettingsSate.userData.id

    const postData = PaginationHelper.getPaginationPostData(getState().manageActivatedUsersState.pagination)

    dispatch(getActivatedUsersAsync(currentUserId, systemRoles, postData)) //refresh system roles site

    dispatch(setIsChangeUserDataDialogDisplayed(false))
    dispatch(resetChangeActivatedUserDataDialog())
  }
}

function _updateActivatedUserDataAsync(userData: BaseUserData): UPDATE_activatedUserDataAction {
  return {
    type: ActionType.UPDATE_activatedUserData,
    payload: delay(adminUpdateUserData(userData))
  }
}

function _updateActivatedUserSystemRoleAsync(tuple: UserSystemRoleTupleForBackend): UPDATE_activatedUserSystemRoleDataAction {
  return {
    type: ActionType.UPDATE_activatedUserSystemRoleData,
    payload: delay(changeUsersSystemRole(tuple))
  }
}


export function resetPasswordAsync(tuple: IdAndPasswordTuple): RESET_activateUserPasswordAction {
  return {
    type: ActionType.RESET_activateUserPassword,
    payload: delay(resetPassword(tuple))
  }
}

