/**
 * Created by janis dähne.
 */


import {
  ResetAction, SET_exerciseReleaseAction,
  SET_isCreatingExerciseReleaseAction
} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogReducer";
import {setIsChangeDialogDisplayedAction} from "../../exerciseReleasesSiteActions";
import {ActionType} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogActionTypes";
import {ExerciseReleaseForBackend, ExerciseReleaseFromBackend} from "../../../../../../types/exerciseRelease";
import {MultiActions} from "../../../../types";
import {setGeneratedCode} from "./setExerciseReleaseActions";
import {EditableExercisePreviewFromBackend} from '../../../../../../types/exercisePreview'


export function setIsCreatingExerciseRelease(isCreating: boolean): SET_isCreatingExerciseReleaseAction {
  return {
    type: ActionType.SET_isCreatingExerciseRelease,
    isCreating
  }
}

export function resetChangeExerciseReleaseDialog(): ResetAction {
  return {
    type: ActionType.RESET
  }
}

export function setExerciseRelease(exerciseRelease: ExerciseReleaseForBackend | null, exercisePreview: EditableExercisePreviewFromBackend): SET_exerciseReleaseAction {
  return {
    type: ActionType.SET_exerciseRelease,
    exerciseRelease,
    exercisePreview
  }
}


export function openCreateExerciseRelease(exercisePreview: EditableExercisePreviewFromBackend): MultiActions {
  return dispatch => {

    dispatch(resetChangeExerciseReleaseDialog())
    dispatch(setIsCreatingExerciseRelease(true))
    dispatch(setIsChangeDialogDisplayedAction(true))
    dispatch(setExerciseRelease(null, exercisePreview))
  }
}

export function openEditExerciseRelease(exerciseRelease: ExerciseReleaseFromBackend, exercisePreview: EditableExercisePreviewFromBackend): MultiActions {
  return dispatch => {

    const {solutionsCount, ...releaseProps} = exerciseRelease

    dispatch(resetChangeExerciseReleaseDialog())
    dispatch(setIsCreatingExerciseRelease(false))
    dispatch(setExerciseRelease({
      ...releaseProps,
      automaticStartAt: exerciseRelease.automaticStartAt ? exerciseRelease.automaticStartAt.toDate() : null,
      automaticEndAt: exerciseRelease.automaticEndAt ? exerciseRelease.automaticEndAt.toDate() : null
    }, exercisePreview))

    //set some property to trigger validation...
    dispatch(setGeneratedCode(exerciseRelease.generatedCode))

    dispatch(setIsChangeDialogDisplayedAction(true))

  }
}

export function cancelEditExerciseRelease() : MultiActions {
  return dispatch => {

    dispatch(setIsChangeDialogDisplayedAction(false))
    dispatch(resetChangeExerciseReleaseDialog())

  }
}
