import {ActionBase, ActionType} from '../../reducers/plangSettingsView/pLangsSettingsViewActionTypes'
import {
  SET_editingPLangIdAction,
  SET_pLang_displayNameAction, SET_pLang_editorHighlightModeNameAction, SET_pLang_fileExtensionsWithDotAction,
  SET_pLang_internalNameAction,
} from '../../reducers/plangSettingsView/pLangsReducer'


/**
 * sets the plang to edit and creates a copy of it for editing
 * @param editingPLangId use -x or 0 to indicate to create a new plang (and use the new id as editingPLangId),
 *  use null to clear editing, crud (create/update) operations should clear the edit too
 */
export function setEditingPLangId(editingPLangId: number | null): SET_editingPLangIdAction {
  return {
    type: ActionType.SET_editingPLangId,
    editingPLangId
  }
}


export function setPLangDisplayName(displayName: string): SET_pLang_displayNameAction {
  return {
    type: ActionType.SET_pLang_displayName,
    displayName
  }
}

export function setPLangInternalName(internalName: string): SET_pLang_internalNameAction {
  return {
    type: ActionType.SET_pLang_internalName,
    internalName
  }
}
export function setPLangFileExtensionsWithDot(fileExtensionsWithDot: string): SET_pLang_fileExtensionsWithDotAction {
  return {
    type: ActionType.SET_pLang_fileExtensionsWithDot,
    fileExtensionsWithDot
  }
}


export function setPLangEditorHighlightModeName(editorHighlightModeName: string): SET_pLang_editorHighlightModeNameAction {
  return {
    type: ActionType.SET_pLang_editorHighlightModeName,
    editorHighlightModeName
  }
}


