import {ActionType} from '../../reducers/plangSettingsView/pLangsSettingsViewActionTypes'
import {delay} from '../../../../debug'
import {
  createPLang,
  deletePLang,
  getPLangs,
  getPLangsWithExtraData,
  updatePLang
} from '../../../communicationLayer/pLangsLayer'
import {GET_pLangsAction} from '../../reducers/plangSettingsView/crud/getPLangsReducer'
import {PLangFullBase, PLangWithExtrasFromBackend} from '../../../types/pLangs'
import {UPDATE_pLangsAction} from '../../reducers/plangSettingsView/crud/updatePlangsReducer'
import {DELETE_pLangAction} from '../../reducers/plangSettingsView/crud/deletePLangReducer'
import {CREATE_pLangAction} from '../../reducers/plangSettingsView/crud/createPLangReducer'
import {GET_pLangsWithExtraDataAction} from '../../reducers/plangSettingsView/crud/getPLangsWithExtraDataReducer'


export function getPLangsAsync(): GET_pLangsAction {
  return {
    type: ActionType.GET_pLangs,
    payload: delay(getPLangs())
  }
}

export function getPLangsWithExtraDataAsync(): GET_pLangsWithExtraDataAction {
  return {
    type: ActionType.GET_pLangsWithExtraData,
    payload: delay(getPLangsWithExtraData())
  }
}



export function createPLangAsync(pLang: PLangFullBase): CREATE_pLangAction {
  return {
    type: ActionType.CREATE_pLang,
    payload: delay(createPLang(pLang))
  }
}


export function updatePLangAsync(pLang: PLangWithExtrasFromBackend): UPDATE_pLangsAction {
  return {
    type: ActionType.UPDATE_pLangs,
    payload: delay(updatePLang(pLang))
  }
}

export function deletePLangAsync(pLang: PLangFullBase): DELETE_pLangAction {
  return {
    type: ActionType.DELETE_pLang,
    payload: delay(deletePLang(pLang.id)),
    meta: {
      pLangId: pLang.id
    }
  }
}
