/**
 * Created by janis dähne.
 */
import {GET_usersAction} from "../../../../reducers/singleGroupSite/dialogs/addUsers/getUsersCrudReducer";
import {ActionType} from "../../../../reducers/singleGroupSite/dialogs/addUsers/addsUserDialogActionTypes";
import {delay} from "../../../../../../debug";
import {getActivatedUsers} from "../../../../../communicationLayer/usersLayer";
import {ADD_membersAction} from "../../../../reducers/singleGroupSite/dialogs/addUsers/addMembersReducer";
import {addMembers} from "../../../../../communicationLayer/groupsLayer";
import {AddUsersToGroupTuplesForBackend, SelectableGroupUserFrontend} from "../../../../../types/group";
import {PaginationPostData} from '../../../../../types/pagination'


export function getUsersAsync(members: ReadonlyArray<SelectableGroupUserFrontend>, paginationPostData: PaginationPostData, groupId: number | null): GET_usersAction {
  return {
    type: ActionType.GET_users,
    payload: delay(getActivatedUsers(paginationPostData, groupId)),
    meta: {
      members
    }
  }
}

export function addMembersAsync(addUsersTuple: AddUsersToGroupTuplesForBackend): ADD_membersAction {
  return {
    type: ActionType.ADD_members,
    payload: delay(addMembers(addUsersTuple)),
  }
}

