/**
 * Created by janis dähne.
 */
import {changeTabVisibility} from "../../../../helpers/editorHelper";
import {MultiActions} from "../../types";
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {setSolutionFilesCodeTemplateTutorView} from "../tutorViewSiteActions";
import {
  SET_codeTemplateEditor_isFileExplorerDisplayedDoEditorAction,
  SET_codeTemplateEditor_selectedTabIdDoEditorAction
} from '../../../reducers/tutorViewSite/editorReducer/codeTemplateTutorViewEditorReducer'
import {ExerciseCodeTemplateFileFullBase} from '../../../../types/exerciseEditor'


export function openTabChangeCodeTemplateEditorTutorView(file: ExerciseCodeTemplateFileFullBase,
                                                         templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>,
                                                         selectedFileId: number,
                                                         codeTemplateId: number
): MultiActions {
  return changeTabVisibility(file, true, templateFiles, selectedFileId, setSolutionFilesCodeTemplateTutorView.bind(null, codeTemplateId),
                             setSelectedTabIdCodeTemplateEditorTutorView
  )
}

export function closeTabChangeCodeTemplateEditorTutorView(file: ExerciseCodeTemplateFileFullBase,
                                                          templateFiles: ReadonlyArray<ExerciseCodeTemplateFileFullBase>,
                                                          selectedFileId: number,
                                                          codeTemplateId: number
): MultiActions {
  return changeTabVisibility(file, false, templateFiles, selectedFileId, setSolutionFilesCodeTemplateTutorView.bind(null, codeTemplateId),
                             setSelectedTabIdCodeTemplateEditorTutorView
  )
}

export function setSelectedTabIdCodeTemplateEditorTutorView(selectedTabIdDoEditor: number): SET_codeTemplateEditor_selectedTabIdDoEditorAction {
  return {
    type: ActionType.SET_codeTemplateEditor_selectedTabIdDoEditor,
    selectedTabIdDoEditor
  }
}

export function setIsFileExplorerDisplayedCodeTemplateEditorTutorView(isFileExplorerDisplayedDoEditor: boolean): SET_codeTemplateEditor_isFileExplorerDisplayedDoEditorAction {
  return {
    type: ActionType.SET_codeTemplateEditor_isFileExplorerDisplayedDoEditor,
    isFileExplorerDisplayedDoEditor
  }
}

