/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {changeTabVisibility} from "../../../../helpers/editorHelper";
import {MultiActions} from "../../types";
import {SolutionFileDoExerciseFullBase} from "../../../../types/exerciseSolution";
import {
  SET_userSolutionEditor_isFileExplorerDisplayedDoEditorAction,
  SET_userSolutionEditor_selectedTabIdDoEditorAction
} from '../../../reducers/tutorViewSite/editorReducer/userSolutionTutorViewEditorReducer'
import {setSolutionFilesUserSolutionTutorView} from "../tutorViewSiteActions";


/**
 * the file
 * @param {SolutionFileDoExerciseFullBase} file the file (won't be used to change something)
 * @param {ReadonlyArray<SolutionFileDoExerciseFullBase>} templateFiles
 * @param {number} selectedFileId
 * @returns {MultiActions}
 */
export function openTabChangeUserSolutionEditorTutorView(file: SolutionFileDoExerciseFullBase,
                                      templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                      selectedFileId: number): MultiActions {
  return changeTabVisibility(file, true, templateFiles, selectedFileId, setSolutionFilesUserSolutionTutorView,
    setSelectedTabIdUserSolutionEditorTutorView)
}

export function closeTabChangeUserSolutionEditorTutorView(file: SolutionFileDoExerciseFullBase,
                                       templateFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>,
                                       selectedFileId: number): MultiActions {
  return changeTabVisibility(file, false, templateFiles, selectedFileId, setSolutionFilesUserSolutionTutorView,
    setSelectedTabIdUserSolutionEditorTutorView)
}


export function setSelectedTabIdUserSolutionEditorTutorView(selectedTabIdDoEditor: number): SET_userSolutionEditor_selectedTabIdDoEditorAction {
  return {
    type: ActionType.SET_userSolutionEditor_selectedTabIdDoEditor,
    selectedTabIdDoEditor
  }
}

export function setIsFileExplorerDisplayedUserSolutionEditorTutorView(isFileExplorerDisplayedDoEditor: boolean): SET_userSolutionEditor_isFileExplorerDisplayedDoEditorAction {
  return {
    type: ActionType.SET_userSolutionEditor_isFileExplorerDisplayedDoEditor,
    isFileExplorerDisplayedDoEditor
  }
}