/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../reducers/tutorViewSite/tutorViewSiteActionTypes";
import {SET_submitTestsForTutorAction} from "../../../reducers/tutorViewSite/tutorViewSiteReducer";
import {AssessedSubmitTestFrontendExclusive} from "../../../../types/testResults";
import {MultiActions} from "../../types";


/**
 * sets the given tests as running and resets there results
 * @param {ReadonlyArray<AssessedSubmitTestFrontendExclusive>} tests
 * @param {ReadonlyArray<AssessedSubmitTestFrontendExclusive>} allTests
 * @returns {MultiActions}
 */
export function setSubmitTestsForTutorAreRunningAndResetResult(tests: ReadonlyArray<AssessedSubmitTestFrontendExclusive>, allTests: ReadonlyArray<AssessedSubmitTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<AssessedSubmitTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true,
          result: null
        }
        : p
    })

    dispatch(setSubmitTestsForTutor(copy))
  }
}

export function setSubmitTestsForTutor(submitTestsForTutor: ReadonlyArray<AssessedSubmitTestFrontendExclusive>): SET_submitTestsForTutorAction {
  return {
    type: ActionType.SET_submitTestsForTutor,
    submitTestsForTutor
  }
}