/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "../dashboardSiteActionTypes";
import {initial, State} from "../dashboardSiteReducer";
import {TestServerPrivateSettings} from "../../../../types/dashboard";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface GET_submitTestServerSettingsAction
  extends ActionBase, ReduxPromiseAction<TestServerPrivateSettings, GET_submitTestServerSettings_PENDINGAction, GET_submitTestServerSettings_FULFILLEDAction, GET_submitTestServerSettings_REJECTEDAction> {
  readonly type: ActionType.GET_submitTestServerSettings
  readonly payload: Promise<TestServerPrivateSettings>
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_submitTestServerSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TestServerPrivateSettings> {
  readonly type: ActionType.GET_submitTestServerSettings_FULFILLED
  readonly payload: TestServerPrivateSettings
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_submitTestServerSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_submitTestServerSettings_PENDINGAction
  | GET_submitTestServerSettings_FULFILLEDAction
  | GET_submitTestServerSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_submitTestServerSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_submitTestServerSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        submitTestServerSettings: action.payload
      }
    case ActionType.GET_submitTestServerSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        submitTestServerSettings: null
      }

    default:
      notExhaustive(action)
      return state
  }
}

