/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "../dashboardSiteActionTypes";
import {initial, State} from "../dashboardSiteReducer";
import {TestServerPrivateSettings} from "../../../../types/dashboard";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface GET_testServerPrivateSettingsAction
  extends ActionBase, ReduxPromiseAction<TestServerPrivateSettings, GET_testServerPrivateSettings_PENDINGAction, GET_testServerPrivateSettings_FULFILLEDAction, GET_testServerPrivateSettings_REJECTEDAction> {
  readonly type: ActionType.GET_testServerPrivateSettings
  readonly payload: Promise<TestServerPrivateSettings>
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPrivateSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_testServerPrivateSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPrivateSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TestServerPrivateSettings> {
  readonly type: ActionType.GET_testServerPrivateSettings_FULFILLED
  readonly payload: TestServerPrivateSettings
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPrivateSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_testServerPrivateSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_testServerPrivateSettings_PENDINGAction
  | GET_testServerPrivateSettings_FULFILLEDAction
  | GET_testServerPrivateSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_testServerPrivateSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_testServerPrivateSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        testServerSettings: action.payload
      }
    case ActionType.GET_testServerPrivateSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        testServerSettings: null
      }

    default:
      notExhaustive(action)
      return state
  }
}

