/**
 * Created by janis dähne.
 */
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {State, initial} from "../doExerciseSiteReducer";
import Logger from "../../../../helpers/logger";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface DELETE_customTestAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_customTest_PENDINGAction, DELETE_customTest_FULFILLEDAction, DELETE_customTest_REJECTEDAction> {
  readonly type: ActionType.DELETE_customTest
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_customTest_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_customTest_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_customTest_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_customTest_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_customTest_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_customTest_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_customTest_PENDINGAction
  | DELETE_customTest_FULFILLEDAction
  | DELETE_customTest_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_customTest_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_customTest_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.DELETE_customTest_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

