/**
 * Created by janis dähne.
 */


import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {initial, State} from "../doExerciseSiteReducer";
import {StoredTestResultTupleFromBackend} from "../../../../types/testResults";
import {mergeTestResultsIntoDoExercise} from "../../../../helpers/convertersAndTransformers";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";

//this is actually only the normal tests, custom tests

export interface GET_allTestResultsAction
  extends ActionBase, ReduxPromiseAction<StoredTestResultTupleFromBackend, GET_allTestResults_PENDINGAction, GET_allTestResults_FULFILLEDAction, GET_allTestResults_REJECTEDAction> {
  readonly type: ActionType.GET_allTestResults
  readonly payload: Promise<StoredTestResultTupleFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_allTestResults_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_allTestResults_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_allTestResults_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<StoredTestResultTupleFromBackend> {
  readonly type: ActionType.GET_allTestResults_FULFILLED
  readonly payload: StoredTestResultTupleFromBackend
}

//automatically dispatched by redux promise middleware
export interface GET_allTestResults_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_allTestResults_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_allTestResults_PENDINGAction
  | GET_allTestResults_FULFILLEDAction
  | GET_allTestResults_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_allTestResults_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_allTestResults_FULFILLED:
      return {
        ...state,
        isLoading: false,
        exercise: mergeTestResultsIntoDoExercise(state.exercise, action.payload)
      }
    case ActionType.GET_allTestResults_REJECTED:
      return {
        ...state,
        isLoading: false,
      }

    default:
      notExhaustive(action)
      return state
  }
}

