import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {initial, State} from "../doExerciseSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface UPDATE_lockSolutionsFlagAction
  extends ActionBase, ReduxPromiseAction<boolean, UPDATE_lockSolutionsFlag_PENDINGAction, UPDATE_lockSolutionsFlag_FULFILLEDAction, UPDATE_lockSolutionsFlag_REJECTEDAction> {
  readonly type: ActionType.UPDATE_lockSolutionsFlag
  readonly payload: Promise<boolean>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_lockSolutionsFlag_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_lockSolutionsFlag_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_lockSolutionsFlag_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<boolean> {
  readonly type: ActionType.UPDATE_lockSolutionsFlag_FULFILLED
  readonly payload: boolean
}

//automatically dispatched by redux promise middleware
export interface UPDATE_lockSolutionsFlag_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_lockSolutionsFlag_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_lockSolutionsFlag_PENDINGAction
  | UPDATE_lockSolutionsFlag_FULFILLEDAction
  | UPDATE_lockSolutionsFlag_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_lockSolutionsFlag_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_lockSolutionsFlag_FULFILLED:
      return {
        ...state,
        isLoading: false,
        lockSolutionsFlag: action.payload,
        isLeftTimeStringDisplayed: action.payload === true ? false : true
      }
    case ActionType.UPDATE_lockSolutionsFlag_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

