/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {initial, State} from "../doExerciseSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface SET_shouldNotCountParticipationAction
  extends ActionBase, ReduxPromiseAction<void, SET_shouldNotCountParticipation_PENDINGAction, SET_shouldNotCountParticipation_FULFILLEDAction, SET_shouldNotCountParticipation_REJECTEDAction> {
  readonly type: ActionType.SET_shouldNotCountParticipation
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface SET_shouldNotCountParticipation_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.SET_shouldNotCountParticipation_PENDING
}

//automatically dispatched by redux promise middleware
export interface SET_shouldNotCountParticipation_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.SET_shouldNotCountParticipation_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface SET_shouldNotCountParticipation_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.SET_shouldNotCountParticipation_REJECTED
  readonly payload: any
}


export type AllActions =
  SET_shouldNotCountParticipation_PENDINGAction
  | SET_shouldNotCountParticipation_FULFILLEDAction
  | SET_shouldNotCountParticipation_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_shouldNotCountParticipation_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.SET_shouldNotCountParticipation_FULFILLED:
      return {
        ...state,
        isLoading: false,
        solution: {
          ...state.solution,
          shouldNotCount: true
        }
      }
    case ActionType.SET_shouldNotCountParticipation_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

