/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {HasFileChangedMap} from "../../../../helpers/editorHelper";
import {DoEditorState} from "./doEditorReducer";


export const initial: DoEditorState = {

  selectedTabIdDoEditor: -1,
  isFileExplorerDisplayedDoEditor: false,
  newFileNameDoEditor: '',
  renamingFileIdDoEditor: NaN, //use nan because a new file could have id -1
  isRenamingFileDoEditor: false,
  renamingFileNameDoEditor: '',

  hasUnsavedChanges: false,
  hasFileChangedMap: {}
}


//--- after editor

export interface SET_afterEditor_hasFileChangedMapAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_hasFileChangedMap
  readonly hasFileChangedMap: HasFileChangedMap
}

export interface SET_afterEditor_hasUnsavedChangesAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_hasUnsavedChanges
  readonly hasUnsavedChanges: boolean
}

export interface SET_afterEditor_selectedTabIdDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_selectedTabIdDoEditor
  readonly selectedTabIdDoEditor: number
}

export interface SET_afterEditor_isFileExplorerDisplayedDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_isFileExplorerDisplayedDoEditor
  readonly isFileExplorerDisplayedDoEditor: boolean
}

export interface SET_afterEditor_newFileNameDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_newFileNameDoEditor
  readonly newFileNameDoEditor: string
}

export interface SET_afterEditor_renamingFileIdDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_renamingFileIdDoEditor
  readonly renamingFileIdDoEditor: number
}

export interface SET_afterEditor_isRenamingFileDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_isRenamingFileDoEditor
  readonly isRenamingFileDoEditor: boolean
}

export interface SET_afterEditor_renamingFileNameDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_afterEditor_renamingFileNameDoEditor
  readonly renamingFileNameDoEditor: string
}


export type AllActions =
  | SET_afterEditor_hasFileChangedMapAction
  | SET_afterEditor_hasUnsavedChangesAction
  | SET_afterEditor_selectedTabIdDoEditorAction
  | SET_afterEditor_isFileExplorerDisplayedDoEditorAction
  | SET_afterEditor_newFileNameDoEditorAction
  | SET_afterEditor_renamingFileIdDoEditorAction
  | SET_afterEditor_isRenamingFileDoEditorAction
  | SET_afterEditor_renamingFileNameDoEditorAction


export function reducer(state: DoEditorState = initial, action: AllActions): DoEditorState {

  switch (action.type) {

    case ActionType.SET_afterEditor_hasFileChangedMap:
      return {
        ...state,
        hasFileChangedMap: action.hasFileChangedMap
      }
    case ActionType.SET_afterEditor_hasUnsavedChanges:
      return {
        ...state,
        hasUnsavedChanges: action.hasUnsavedChanges
      }

    case ActionType.SET_afterEditor_selectedTabIdDoEditor:
      return {
        ...state,
        selectedTabIdDoEditor: action.selectedTabIdDoEditor
      }
    case ActionType.SET_afterEditor_isFileExplorerDisplayedDoEditor:
      return {
        ...state,
        isFileExplorerDisplayedDoEditor: action.isFileExplorerDisplayedDoEditor
      }
    case ActionType.SET_afterEditor_newFileNameDoEditor:
      return {
        ...state,
        newFileNameDoEditor: action.newFileNameDoEditor
      }
    case ActionType.SET_afterEditor_renamingFileIdDoEditor:
      return {
        ...state,
        renamingFileIdDoEditor: action.renamingFileIdDoEditor
      }
    case ActionType.SET_afterEditor_isRenamingFileDoEditor:
      return {
        ...state,
        isRenamingFileDoEditor: action.isRenamingFileDoEditor
      }
    case ActionType.SET_afterEditor_renamingFileNameDoEditor:
      return {
        ...state,
        renamingFileNameDoEditor: action.renamingFileNameDoEditor
      }

    default:
      notExhaustive(action)
      return state
  }
}

