/**
 * Created by janis dähne.
 */

import {SolutionFileDoExerciseFullBase, SolutionDoExerciseFullBase} from "../../../../types/exerciseSolution";
import * as moment from "moment";
import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {FrontendSettingsManager} from "../../../../helpers/frontendSettingsManager";
import {AfterSolutionDoExerciseFullBase} from '../../../../types/exerciseAfterSolution'

export type State = AfterSolutionDoExerciseFullBase


export const initial: State = {
  id: -1,
  pLangId: -1,
  mainFileId: -1,
  lastUpdatedAt: moment(),
  solutionFiles: [],
  userId: -1,
  releaseId: -1
}


export interface SET_afterSolutionFirstDummyAction extends ActionBase {
  readonly type: ActionType.SET_afterSolutionFirstDummy
  readonly afterSolution: AfterSolutionDoExerciseFullBase
}

export interface SET_afterSolutionFilesAction extends ActionBase {
  readonly type: ActionType.SET_afterSolutionFiles
  readonly solutionFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>
}

export interface SET_afterSolutionFilesAction extends ActionBase {
  readonly type: ActionType.SET_afterSolutionFiles
  readonly solutionFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>
}

export interface SET_afterMainFileIdAction extends ActionBase {
  readonly type: ActionType.SET_afterMainFileId
  readonly mainFileId: number
}


export type AllActions =
  | SET_afterSolutionFilesAction
  | SET_afterMainFileIdAction
  | SET_afterSolutionFirstDummyAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_afterSolutionFirstDummy:
      return {
        ...action.afterSolution
      }

    case ActionType.SET_afterSolutionFiles:
      return {
        ...state,
        solutionFiles: action.solutionFiles
      }

    case ActionType.SET_afterMainFileId:
      return {
        ...state,
        mainFileId: action.mainFileId
      }


    default:
      //only working for > 1 types
      notExhaustive(action)
      return state
  }
}

