/**
 * Created by janis dähne.
 */

import {ExerciseReleaseDoExerciseFromBackend} from "../../../../types/doExercise";
import {ActionBase, ActionType} from "../doExerciseSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReleaseDurationType} from "../../../../types/ReleaseDurationType";
import {ReleaseStartType} from "../../../../types/ReleaseStartType";

export type State = ExerciseReleaseDoExerciseFromBackend


export const initial: State = {
  id: -1,
  pLangId: -1,
  releaseCode: '',
  releaseDurationType: ReleaseDurationType.Infinitely,
  availableWorkingTimeInMinutes: -1,
  hasLimitedWorkingTime: false,
  automaticEndAt: null,
  isReleased: false,
  hasAutomaticAssessmentFinished: false,
  releaseStartType: ReleaseStartType.Manual,
  hideSiteHeaderBar: false,
  shouldClearClipboard: false,
  hideExerciseLeaveActions: false,
  hidePrintOptions: false,
  showAdditionalLogButton: false,
  maxManualPoints: null,
}

export interface SET_exerciseReleaseAction extends ActionBase {
  readonly type: ActionType.SET_exerciseRelease
  readonly exerciseRelease: ExerciseReleaseDoExerciseFromBackend
}


export interface ResetAction extends ActionBase {
  readonly type: ActionType.RESET
}

export type AllActions =
  SET_exerciseReleaseAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_exerciseRelease:
      return {
        ...action.exerciseRelease
      }


    default:
      //somehow only working with 2 or more cases...
      //notExhaustive(action)
      return state
  }
}

