import {ActionBase, ActionType} from '../../editCustomProjectSiteActionTypes'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../../index'
import {initial, State} from '../../editCustomProjectSiteReducer'
import {notExhaustive} from '../../../_notExhausiveHelper'


export interface ATTACH_customProjectMarkdownAssetPreviewAction
  extends ActionBase, ReduxPromiseAction<void, ATTACH_customProjectMarkdownAssetPreview_PENDINGAction, ATTACH_customProjectMarkdownAssetPreview_FULFILLEDAction, ATTACH_customProjectMarkdownAssetPreview_REJECTEDAction> {
  readonly type: ActionType.ATTACH_customProjectMarkdownAssetPreview
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface ATTACH_customProjectMarkdownAssetPreview_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.ATTACH_customProjectMarkdownAssetPreview_PENDING
}

//automatically dispatched by redux promise middleware
export interface ATTACH_customProjectMarkdownAssetPreview_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.ATTACH_customProjectMarkdownAssetPreview_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface ATTACH_customProjectMarkdownAssetPreview_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.ATTACH_customProjectMarkdownAssetPreview_REJECTED
  readonly payload: any
}


export type AllActions =
  ATTACH_customProjectMarkdownAssetPreview_PENDINGAction
  | ATTACH_customProjectMarkdownAssetPreview_FULFILLEDAction
  | ATTACH_customProjectMarkdownAssetPreview_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.ATTACH_customProjectMarkdownAssetPreview_PENDING:
      return {
        ...state,
        isAddCustomProjectAssetFilesModalBusy: true
      }
    case ActionType.ATTACH_customProjectMarkdownAssetPreview_FULFILLED:
      return {
        ...state,
        isAddCustomProjectAssetFilesModalBusy: false
      }
    case ActionType.ATTACH_customProjectMarkdownAssetPreview_REJECTED:
      return {
        ...state,
        isAddCustomProjectAssetFilesModalBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

