import {initial, State} from '../../editCustomProjectSiteReducer'
import {notExhaustive} from '../../../_notExhausiveHelper'
import {
  GET_allUserAssetPreviews_FULFILLEDAction,
  GET_allUserAssetPreviews_PENDINGAction,
  GET_callUserAssetPreviews_REJECTEDAction
} from '../../../doExerciseSite/crud/assets/getAllUserAssetPreviewsReducer'
import {ActionType as ActionType} from '../../../doExerciseSite/doExerciseSiteActionTypes'


export type AllActions =
  GET_allUserAssetPreviews_PENDINGAction
  | GET_allUserAssetPreviews_FULFILLEDAction
  | GET_callUserAssetPreviews_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_allUserAssetPreviews_PENDING:
      return {
        ...state,
        isLoading: true,
        isAddCustomProjectCustomTestAssetFilesModalBusy: true,
        isAddCustomProjectAssetFilesModalBusy: true,
      }
    case ActionType.GET_allUserAssetPreviews_FULFILLED:
      return {
        ...state,
        isLoading: false,
        isAddCustomProjectCustomTestAssetFilesModalBusy: false,
        isAddCustomProjectAssetFilesModalBusy: false,
        allCustomProjectAssetFilePreviews: action.payload
      }
    case ActionType.GET_allUserAssetPreviews_REJECTED:
      return {
        ...state,
        isLoading: false,
        isAddCustomProjectCustomTestAssetFilesModalBusy: false,
        isAddCustomProjectAssetFilesModalBusy: false,
        allCustomProjectAssetFilePreviews: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

