/**
 * Created by janis dähne.
 */

import {DoEditorState, initial as initialEditorState} from "../../doExerciseSite/editorReducers/doEditorReducer";
import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {HasFileChangedMap} from "../../../../helpers/editorHelper";
import {notExhaustive} from "../../_notExhausiveHelper";

export type State = DoEditorState


export const initial: State = initialEditorState


//--- do editor

export interface SET_hasFileChangedMapAction extends ActionBase {
  readonly type: ActionType.SET_hasFileChangedMap
  readonly hasFileChangedMap: HasFileChangedMap
}

export interface SET_hasUnsavedChangesAction extends ActionBase {
  readonly type: ActionType.SET_hasUnsavedChanges
  readonly hasUnsavedChanges: boolean
}

export interface SET_selectedTabIdCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_selectedTabIdCustomProjectSolutionEditor
  readonly selectedTabIdCustomProjectSolutionEditor: number
}

export interface SET_isFileExplorerDisplayedCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_isFileExplorerDisplayedCustomProjectSolutionEditor
  readonly isFileExplorerDisplayedCustomProjectSolutionEditor: boolean
}

export interface SET_newFileNameCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_newFileNameCustomProjectSolutionEditor
  readonly newFileNameCustomProjectSolutionEditor: string
}

export interface SET_renamingFileIdCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_renamingFileIdCustomProjectSolutionEditor
  readonly renamingFileIdCustomProjectSolutionEditor: number
}

export interface SET_isRenamingFileCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_isRenamingFileCustomProjectSolutionEditor
  readonly isRenamingFileCustomProjectSolutionEditor: boolean
}

export interface SET_renamingFileNameCustomProjectSolutionEditorAction extends ActionBase {
  readonly type: ActionType.SET_renamingFileNameCustomProjectSolutionEditor
  readonly renamingFileNameCustomProjectSolutionEditor: string
}


export type AllActions =
  SET_selectedTabIdCustomProjectSolutionEditorAction
  | SET_isFileExplorerDisplayedCustomProjectSolutionEditorAction
  | SET_newFileNameCustomProjectSolutionEditorAction
  | SET_renamingFileIdCustomProjectSolutionEditorAction
  | SET_isRenamingFileCustomProjectSolutionEditorAction
  | SET_renamingFileNameCustomProjectSolutionEditorAction
  | SET_hasUnsavedChangesAction
  | SET_hasFileChangedMapAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_selectedTabIdCustomProjectSolutionEditor:
      return {
        ...state,
        selectedTabIdDoEditor: action.selectedTabIdCustomProjectSolutionEditor
      }
    case ActionType.SET_isFileExplorerDisplayedCustomProjectSolutionEditor:
      return {
        ...state,
        isFileExplorerDisplayedDoEditor: action.isFileExplorerDisplayedCustomProjectSolutionEditor
      }
    case ActionType.SET_newFileNameCustomProjectSolutionEditor:
      return {
        ...state,
        newFileNameDoEditor: action.newFileNameCustomProjectSolutionEditor
      }
    case ActionType.SET_renamingFileIdCustomProjectSolutionEditor:
      return {
        ...state,
        renamingFileIdDoEditor: action.renamingFileIdCustomProjectSolutionEditor
      }
    case ActionType.SET_isRenamingFileCustomProjectSolutionEditor:
      return {
        ...state,
        isRenamingFileDoEditor: action.isRenamingFileCustomProjectSolutionEditor
      }
    case ActionType.SET_renamingFileNameCustomProjectSolutionEditor:
      return {
        ...state,
        renamingFileNameDoEditor: action.renamingFileNameCustomProjectSolutionEditor
      }
    case ActionType.SET_hasUnsavedChanges:
      return {
        ...state,
        hasUnsavedChanges: action.hasUnsavedChanges
      }
    case ActionType.SET_hasFileChangedMap:
      return {
        ...state,
        hasFileChangedMap: action.hasFileChangedMap
      }


    default:
      notExhaustive(action)
      return state
  }
}

