/**
 * Created by janis dähne.
 */

import {CustomProjectDescriptionFullBase} from "../../../../types/customProjects";
import {getNextFrontendId} from "../../../../helpers/frontendIdHelper";
import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {FileWithData} from "../../../../types/exerciseEditor";
import {notExhaustive} from "../../_notExhausiveHelper";

export type State = CustomProjectDescriptionFullBase


export const initial: State = {
  id: -1,
  assets: [],
  content:
`[question=md]

...`,
}

export interface SET_contentAction extends ActionBase {
  readonly type: ActionType.SET_content
  readonly content: string
}

export interface SET_assetsAction extends ActionBase {
  readonly type: ActionType.SET_assets
  readonly assets: ReadonlyArray<FileWithData>
}


export type AllActions =
  SET_contentAction
  | SET_assetsAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_content:
      return {
        ...state,
        content: action.content
      }

    case ActionType.SET_assets:
      return {
        ...state,
        assets: action.assets
      }

    default:
      notExhaustive(action)
      return state
  }
}

