/**
 * Created by janis dähne.
 */

import {CustomProjectSolutionFileFullBase, CustomProjectSolutionFullBase} from "../../../../types/customProjects";
import {getNextFrontendId} from "../../../../helpers/frontendIdHelper";
import * as moment from "moment";
import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";

export type State = CustomProjectSolutionFullBase


export const initial: State = {
  id: -1,
  createdAt: null,
  mainFileId: null,
  pLangId: -1,
  solutionFiles: []
}


export interface SET_solutionFilesAction extends ActionBase {
  readonly type: ActionType.SET_solutionFiles
  readonly solutionFiles: ReadonlyArray<CustomProjectSolutionFileFullBase>
}

export interface SET_mainFileIdAction extends ActionBase {
  readonly type: ActionType.SET_mainFileId
  readonly mainFileId: number
}

export type AllActions =
  SET_solutionFilesAction
  | SET_mainFileIdAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_solutionFiles:
      return {
        ...state,
        solutionFiles: action.solutionFiles
      }

    case ActionType.SET_mainFileId:
      return {
        ...state,
        mainFileId: action.mainFileId
      }

    default:
      notExhaustive(action)
      return state
  }
}

