/**
 * Created by janis dähne.
 */
import {Action} from "redux";
import {notExhaustive} from "../../../_notExhausiveHelper";
import {ActionTypeGlobal, RESET_GlobalAction} from '../../../globalActions'

export type State = {
  readonly isBusy: boolean
  readonly selectedTagIds: ReadonlyArray<number>
  //use the tags from the tags panel
}


export const initial: State = {
  isBusy: false,
  selectedTagIds: []
}

export interface ActionBase extends Action {
  readonly type: ActionType
}


export enum ActionType {
  SET_selectedTagIds = 'changeSelectedTagsDialogReducer_SET_selectedTagIds',
  RESET = 'changeSelectedTagsDialogReducer_RESET',
}


export interface SET_selectedTagIdsAction extends ActionBase {
  readonly type: ActionType.SET_selectedTagIds
  readonly selectedTagIds: ReadonlyArray<number>
}


export interface ResetAction extends ActionBase {
  readonly type: ActionType.RESET
}

export type AllActions =
  ResetAction
  | SET_selectedTagIdsAction

  | RESET_GlobalAction

export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_selectedTagIds:
      return {
        ...state,
        selectedTagIds: action.selectedTagIds

      }
    case ActionType.RESET:
    case ActionTypeGlobal.RESET_Global:
      return {
        ...initial
      }

    default:
      notExhaustive(action)
      return state
  }
}

