/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import {ExerciseCodeTemplateFullBase} from "../../../../types/exerciseEditor";
import {ActionBase, ActionType} from "../editorExerciseSiteActionTypes";

export type State = ReadonlyArray<ExerciseCodeTemplateFullBase>


export const initial: State = []


export interface SET_codeTemplatesAction extends ActionBase {
  readonly type: ActionType.SET_codeTemplates
  readonly codeTemplates: ReadonlyArray<ExerciseCodeTemplateFullBase>
}


export interface ResetAction extends ActionBase {
  readonly type: ActionType.RESET
}

export type AllActions =
  SET_codeTemplatesAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_codeTemplates:
      return [...action.codeTemplates]

    default:
      //somehow only working with 2 or more cases...
      //notExhaustive(action)
      return state
  }
}

