import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from './globalSystemSettingsActionTypes'
import {initial, State} from './globalSystemSettingsReducer'
import {TestServerPublicSettings} from '../../../types/systemSettings'



export interface GET_testServerPublicSettingsAction
  extends ActionBase, ReduxPromiseAction<TestServerPublicSettings, GET_testServerPublicSettings_PENDINGAction, GET_testServerPublicSettings_FULFILLEDAction, GET_testServerPublicSettings_REJECTEDAction> {
  readonly type: ActionType.GET_testServerPublicSettings
  readonly payload: Promise<TestServerPublicSettings>
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPublicSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_testServerPublicSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPublicSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TestServerPublicSettings> {
  readonly type: ActionType.GET_testServerPublicSettings_FULFILLED
  readonly payload: TestServerPublicSettings
}

//automatically dispatched by redux promise middleware
export interface GET_testServerPublicSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_testServerPublicSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_testServerPublicSettings_PENDINGAction
  | GET_testServerPublicSettings_FULFILLEDAction
  | GET_testServerPublicSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_testServerPublicSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_testServerPublicSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        testServerPublicSettings: action.payload
      }
    case ActionType.GET_testServerPublicSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        testServerPublicSettings: initial.testServerPublicSettings
      }

    default:
      notExhaustive(action)
      return state
  }
}

