/**
 * Created by janis dähne.
 */

import {Action} from "redux";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {initial, State} from "./changeGroupRolesDialogReducer";
import {ActionType, ActionBase} from "./groupRolesDialogActionTypes";
import {GroupRoleWithPermissionFullBase} from "../../../../types/groupRoles";




export interface CREATE_groupRoleAction
  extends ActionBase, ReduxPromiseAction<GroupRoleWithPermissionFullBase, CREATE_groupRole_PENDINGAction, CREATE_groupRole_FULFILLEDAction, CREATE_groupRole_REJECTEDAction> {
  readonly type: ActionType.CREATE_groupRole
  readonly payload: Promise<GroupRoleWithPermissionFullBase>
}

//automatically dispatched by redux promise middleware
export interface CREATE_groupRole_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.CREATE_groupRole_PENDING
}

//automatically dispatched by redux promise middleware
export interface CREATE_groupRole_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<GroupRoleWithPermissionFullBase> {
  readonly type: ActionType.CREATE_groupRole_FULFILLED
  readonly payload: GroupRoleWithPermissionFullBase
}

//automatically dispatched by redux promise middleware
export interface CREATE_groupRole_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<GroupRoleWithPermissionFullBase> {
  readonly type: ActionType.CREATE_groupRole_REJECTED
  readonly payload: any
}


export type AllActions =
  CREATE_groupRole_PENDINGAction
  | CREATE_groupRole_FULFILLEDAction
  | CREATE_groupRole_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.CREATE_groupRole_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.CREATE_groupRole_FULFILLED:
      return {
        ...state,
        isBusy: false,
      }
    case ActionType.CREATE_groupRole_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

