/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "./actionTypes";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {initial, State} from "./changeGroupReducer";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface DELETE_groupAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_group_PENDINGAction, DELETE_group_FULFILLEDAction, DELETE_group_REJECTEDAction> {
  readonly type: ActionType.DELETE_group
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_group_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_group_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_group_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_group_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_group_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_group_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_group_PENDINGAction
  | DELETE_group_FULFILLEDAction
  | DELETE_group_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_group_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.DELETE_group_FULFILLED:
      return {
        ...state,
        isBusy: false,
      }
    case ActionType.DELETE_group_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}