/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./ownExercisesSiteActionTypes";
import {initial, State} from "./ownExercisesSiteReducer";
import Logger from "../../../helpers/logger";

//there is actually no difference in deleting an own exercise or group exercise...
//but maybe we need to do some other actions??

export interface DELETE_ownExerciseAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_ownExercise_PENDINGAction, DELETE_ownExercise_FULFILLEDAction, DELETE_ownExercise_REJECTEDAction> {
  readonly type: ActionType.DELETE_ownExercise
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_ownExercise_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_ownExercise_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_ownExercise_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_ownExercise_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_ownExercise_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_ownExercise_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_ownExercise_PENDINGAction
  | DELETE_ownExercise_FULFILLEDAction
  | DELETE_ownExercise_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_ownExercise_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_ownExercise_FULFILLED:
      return {
        ...state,
        isLoading: false, //then reload list
      }
    case ActionType.DELETE_ownExercise_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

