import {SingleGroupPreviewExerciseTupleFromBackend} from '../../../../types/exercisePreview'
import {notExhaustive} from '../../_notExhausiveHelper'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {ActionBase, ActionType} from './submissionsSiteActionTypes'
import {initial, State} from './submissionsSiteReducer'


export interface GET_singleGroupExerciseAction
  extends ActionBase, ReduxPromiseAction<SingleGroupPreviewExerciseTupleFromBackend, GET_singleGroupExercise_PENDINGAction, GET_singleGroupExercise_FULFILLEDAction, GET_GET_singleGroupExercise_REJECTEDAction> {
  readonly type: ActionType.GET_singleGroupExercise
  readonly payload: Promise<SingleGroupPreviewExerciseTupleFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_singleGroupExercise_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_singleGroupExercise_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_singleGroupExercise_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<SingleGroupPreviewExerciseTupleFromBackend> {
  readonly type: ActionType.GET_singleGroupExercise_FULFILLED
  readonly payload: SingleGroupPreviewExerciseTupleFromBackend
}

//automatically dispatched by redux promise middleware
export interface GET_GET_singleGroupExercise_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_singleGroupExercise_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_singleGroupExercise_PENDINGAction
  | GET_singleGroupExercise_FULFILLEDAction
  | GET_GET_singleGroupExercise_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_singleGroupExercise_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_singleGroupExercise_FULFILLED:
      return {
        ...state,
        isLoading: false,
        exercise: action.payload.exercisePreview,
        group: action.payload.groupPreview,
        groupRole: action.payload.groupRole
      }
    case ActionType.GET_singleGroupExercise_REJECTED:
      return {
        ...state,
        isLoading: false,
        exercise: null,
        group: null,
        groupRole: null,
      }

    default:
      notExhaustive(action)
      return state
  }
}

