import {ActionBase, ActionType} from '../pLangsSettingsViewActionTypes'
import {initial, State} from '../pLangsReducer'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {notExhaustive} from '../../_notExhausiveHelper'
import {PLangWithExtrasFromBackend} from '../../../../types/pLangs'


export interface GET_pLangsWithExtraDataAction
  extends ActionBase, ReduxPromiseAction<ReadonlyArray<PLangWithExtrasFromBackend>, GET_pLangsWithExtraData_PENDINGAction, GET_pLangsWithExtraData_FULFILLEDAction, GET_pLangsWithExtraData_REJECTEDAction> {
  readonly type: ActionType.GET_pLangsWithExtraData
  readonly payload: Promise<ReadonlyArray<PLangWithExtrasFromBackend>>
}

//automatically dispatched by redux promise middleware
export interface GET_pLangsWithExtraData_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_pLangsWithExtraData_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_pLangsWithExtraData_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<PLangWithExtrasFromBackend>> {
  readonly type: ActionType.GET_pLangsWithExtraData_FULFILLED
  readonly payload: ReadonlyArray<PLangWithExtrasFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_pLangsWithExtraData_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_pLangsWithExtraData_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_pLangsWithExtraData_PENDINGAction
  | GET_pLangsWithExtraData_FULFILLEDAction
  | GET_pLangsWithExtraData_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_pLangsWithExtraData_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_pLangsWithExtraData_FULFILLED:
      return {
        ...state,
        isLoading: false,
        pLangsWithExtraData: action.payload
      }
    case ActionType.GET_pLangsWithExtraData_REJECTED:
      return {
        ...state,
        isLoading: false,
        pLangsWithExtraData: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

