/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./singleGroupSiteActionTypes";
import {initial, State} from "./singleGroupSiteReducer";
import Logger from "../../../helpers/logger";



export type Meta = {
  readonly shouldHideLoading: boolean
}

export interface SET_memberGroupRoleAction
  extends ActionBase, ReduxPromiseAction<void, SET_memberGroupRole_PENDINGAction, SET_memberGroupRole_FULFILLEDAction, SET_memberGroupRole_REJECTEDAction, Meta> {
  readonly type: ActionType.SET_memberGroupRole
  readonly payload: Promise<void>
  readonly meta: Meta
}

//automatically dispatched by redux promise middleware
export interface SET_memberGroupRole_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.SET_memberGroupRole_PENDING
  readonly meta: Meta
}

//automatically dispatched by redux promise middleware
export interface SET_memberGroupRole_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void, Meta> {
  readonly type: ActionType.SET_memberGroupRole_FULFILLED
  readonly payload: void
  readonly meta: Meta
}

//automatically dispatched by redux promise middleware
export interface SET_memberGroupRole_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void, Meta> {
  readonly type: ActionType.SET_memberGroupRole_REJECTED
  readonly payload: any
  readonly meta: Meta
}


export type AllActions =
  SET_memberGroupRole_PENDINGAction
  | SET_memberGroupRole_FULFILLEDAction
  | SET_memberGroupRole_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_memberGroupRole_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.SET_memberGroupRole_FULFILLED:
      return {
        ...state,
        isLoading: action.meta.shouldHideLoading ? false : state.isLoading
      }
    case ActionType.SET_memberGroupRole_REJECTED:
      return {
        ...state,
        isLoading: action.meta.shouldHideLoading ? false : state.isLoading
      }

    default:
      notExhaustive(action)
      return state
  }
}

