/**
 * Created by janis dähne.
 */

import {Action} from "redux";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {SystemRoleFullBase} from "../../../../types/userData";
import {initial, State} from "./changeSystemRolesDialogReducer";
import {ActionType, ActionBase} from "./changeSystemRoleDIalogActionTypes";


export interface UPDATE_systemRoleAction
  extends ActionBase, ReduxPromiseAction<SystemRoleFullBase, UPDATE_systemRole_PENDINGAction, UPDATE_systemRole_FULFILLEDAction, UPDATE_systemRole_REJECTEDAction> {
  readonly type: ActionType.UPDATE_systemRole
  readonly payload: Promise<SystemRoleFullBase>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_systemRole_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_systemRole_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_systemRole_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<SystemRoleFullBase> {
  readonly type: ActionType.UPDATE_systemRole_FULFILLED
  readonly payload: SystemRoleFullBase
}

//automatically dispatched by redux promise middleware
export interface UPDATE_systemRole_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<SystemRoleFullBase> {
  readonly type: ActionType.UPDATE_systemRole_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_systemRole_PENDINGAction
  | UPDATE_systemRole_FULFILLEDAction
  | UPDATE_systemRole_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_systemRole_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.UPDATE_systemRole_FULFILLED:
      return {
        ...state,
        isBusy: false
      }
    case ActionType.UPDATE_systemRole_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}


