import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from './systemRolesSiteActionTypes'
import {State, initial} from './systemRolesSiteReducer'


export interface GET_lockedSystemRoleIdsAction
  extends ActionBase, ReduxPromiseAction<ReadonlyArray<number>, GET_lockedSystemRoleIds_PENDINGAction, GET_lockedSystemRoleIds_FULFILLEDAction, GET_lockedSystemRoleIds_REJECTEDAction> {
  readonly type: ActionType.GET_lockedSystemRoleIds
  readonly payload: Promise<ReadonlyArray<number>>
}

//automatically dispatched by redux promise middleware
export interface GET_lockedSystemRoleIds_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_lockedSystemRoleIds_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_lockedSystemRoleIds_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<number>> {
  readonly type: ActionType.GET_lockedSystemRoleIds_FULFILLED
  readonly payload: ReadonlyArray<number>
}

//automatically dispatched by redux promise middleware
export interface GET_lockedSystemRoleIds_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_lockedSystemRoleIds_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_lockedSystemRoleIds_PENDINGAction
  | GET_lockedSystemRoleIds_FULFILLEDAction
  | GET_lockedSystemRoleIds_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_lockedSystemRoleIds_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_lockedSystemRoleIds_FULFILLED:
      return {
        ...state,
        isLoading: false,
        lockedSystemRoleIds: action.payload
      }
    case ActionType.GET_lockedSystemRoleIds_REJECTED:
      return {
        ...state,
        isLoading: false,
        lockedSystemRoleIds: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

