import {ActionBase, ActionType} from '../systemSettingsSiteActionTypes'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {State, initial} from '../systemSettingsSiteReducer'
import {notExhaustive} from '../../_notExhausiveHelper'
import {GroupPreviewFromBackend} from '../../../../types/group'


export interface GET_allDefaultGroupsAction
  extends ActionBase, ReduxPromiseAction<ReadonlyArray<GroupPreviewFromBackend>, GET_allDefaultGroups_PENDINGAction, GET_allDefaultGroups_FULFILLEDAction, GET_allDefaultGroups_REJECTEDAction> {
  readonly type: ActionType.GET_allDefaultGroups
  readonly payload: Promise<ReadonlyArray<GroupPreviewFromBackend>>
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultGroups_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_allDefaultGroups_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultGroups_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<GroupPreviewFromBackend>> {
  readonly type: ActionType.GET_allDefaultGroups_FULFILLED
  readonly payload: ReadonlyArray<GroupPreviewFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultGroups_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_allDefaultGroups_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_allDefaultGroups_PENDINGAction
  | GET_allDefaultGroups_FULFILLEDAction
  | GET_allDefaultGroups_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_allDefaultGroups_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_allDefaultGroups_FULFILLED:
      return {
        ...state,
        isLoading: false,
        allDefaultGroups: action.payload
      }
    case ActionType.GET_allDefaultGroups_REJECTED:
      return {
        ...state,
        isLoading: false,
        allDefaultGroups: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

