import {ActionBase, ActionType} from '../systemSettingsSiteActionTypes'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {State, initial} from '../systemSettingsSiteReducer'
import {notExhaustive} from '../../_notExhausiveHelper'
import {GroupRoleFullBase} from '../../../../types/groupRoles'


export interface GET_allDefaultRolesAction
  extends ActionBase, ReduxPromiseAction<ReadonlyArray<GroupRoleFullBase>, GET_allDefaultRoles_PENDINGAction, GET_allDefaultRoles_FULFILLEDAction, GET_allDefaultRoles_REJECTEDAction> {
  readonly type: ActionType.GET_allDefaultRoles
  readonly payload: Promise<ReadonlyArray<GroupRoleFullBase>>
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultRoles_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_allDefaultRoles_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultRoles_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ReadonlyArray<GroupRoleFullBase>> {
  readonly type: ActionType.GET_allDefaultRoles_FULFILLED
  readonly payload: ReadonlyArray<GroupRoleFullBase>
}

//automatically dispatched by redux promise middleware
export interface GET_allDefaultRoles_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_allDefaultRoles_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_allDefaultRoles_PENDINGAction
  | GET_allDefaultRoles_FULFILLEDAction
  | GET_allDefaultRoles_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_allDefaultRoles_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_allDefaultRoles_FULFILLED:
      return {
        ...state,
        isLoading: false,
        allDefaultRoles: action.payload
      }
    case ActionType.GET_allDefaultRoles_REJECTED:
      return {
        ...state,
        isLoading: false,
        allDefaultRoles: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

