import {TestServerPublicSettings} from '../../../../types/systemSettings'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from '../../index'
import {ActionBase, ActionType} from '../systemSettingsSiteActionTypes'
import {State, initial} from '../systemSettingsSiteReducer'
import {notExhaustive} from '../../_notExhausiveHelper'


export interface GET_submitTestServerPublicSettingsAction
  extends ActionBase, ReduxPromiseAction<TestServerPublicSettings, GET_submitTestServerPublicSettings_PENDINGAction, GET_submitTestServerPublicSettings_FULFILLEDAction, GET_submitTestServerPublicSettings_REJECTEDAction> {
  readonly type: ActionType.GET_submitTestServerPublicSettings
  readonly payload: Promise<TestServerPublicSettings>
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerPublicSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_submitTestServerPublicSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerPublicSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TestServerPublicSettings> {
  readonly type: ActionType.GET_submitTestServerPublicSettings_FULFILLED
  readonly payload: TestServerPublicSettings
}

//automatically dispatched by redux promise middleware
export interface GET_submitTestServerPublicSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_submitTestServerPublicSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_submitTestServerPublicSettings_PENDINGAction
  | GET_submitTestServerPublicSettings_FULFILLEDAction
  | GET_submitTestServerPublicSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_submitTestServerPublicSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_submitTestServerPublicSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        submitTestServerPublicSettings: action.payload
      }
    case ActionType.GET_submitTestServerPublicSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        submitTestServerPublicSettings: initial.submitTestServerPublicSettings
      }

    default:
      notExhaustive(action)
      return state
  }
}

