import {ActionBase, ActionType} from '../systemSettingsSiteActionTypes'
import {SystemSettingsFromBackend} from '../../../../types/systemSettings'
import {State, initial} from '../systemSettingsSiteReducer'
import {ReduxPromiseAction, ReduxPromiseFulfilledAction,ReduxPromiseRejectedAction} from '../../index'
import {notExhaustive} from '../../_notExhausiveHelper'

export interface GET_systemSettingsAction
  extends ActionBase, ReduxPromiseAction<SystemSettingsFromBackend, GET_systemSettings_PENDINGAction, GET_systemSettings_FULFILLEDAction, GET_systemSettings_REJECTEDAction> {
  readonly type: ActionType.GET_systemSettings
  readonly payload: Promise<SystemSettingsFromBackend>
}

//automatically dispatched by redux promise middleware
export interface GET_systemSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_systemSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_systemSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<SystemSettingsFromBackend> {
  readonly type: ActionType.GET_systemSettings_FULFILLED
  readonly payload: SystemSettingsFromBackend
}

//automatically dispatched by redux promise middleware
export interface GET_systemSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_systemSettings_REJECTED
  readonly payload: any
}



export type AllActions =
  GET_systemSettings_PENDINGAction
  | GET_systemSettings_FULFILLEDAction
  | GET_systemSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_systemSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_systemSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        systemSettings: action.payload
      }
    case ActionType.GET_systemSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
      }

    default:
      notExhaustive(action)
      return state
  }
}

