/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../../index";
import Logger from "../../../../../helpers/logger";
import {SolutionTupleFromBackend} from "../../../../../types/exerciseSolution";
import {ActionBase, ActionType} from "../../tutorViewSiteActionTypes";
import {initial, State} from "../../tutorViewSiteReducer";
import {AfterSolutionDoExerciseFullBase} from '../../../../../types/exerciseAfterSolution'

export interface GET_user_afterSolutionAction
  extends ActionBase, ReduxPromiseAction<AfterSolutionDoExerciseFullBase, GET_user_afterSolution_PENDINGAction, GET_user_afterSolution_FULFILLEDAction, GET_user_afterSolution_REJECTEDAction> {
  readonly type: ActionType.GET_user_afterSolution
  readonly payload: Promise<AfterSolutionDoExerciseFullBase>
}

//automatically dispatched by redux promise middleware
export interface GET_user_afterSolution_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_user_afterSolution_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_user_afterSolution_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<AfterSolutionDoExerciseFullBase> {
  readonly type: ActionType.GET_user_afterSolution_FULFILLED
  readonly payload: AfterSolutionDoExerciseFullBase
}

//automatically dispatched by redux promise middleware
export interface GET_user_afterSolution_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_user_afterSolution_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_user_afterSolution_PENDINGAction
  | GET_user_afterSolution_FULFILLEDAction
  | GET_user_afterSolution_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_user_afterSolution_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_user_afterSolution_FULFILLED:
      return {
        ...state,
        isLoading: false,
        userAfterSolution: action.payload,
      }
    case ActionType.GET_user_afterSolution_REJECTED:
      return {
        ...state,
        isLoading: false,
        userAfterSolution: null,
      }

    default:
      notExhaustive(action)
      return state
  }
}

