/**
 * Created by janis dähne.
 */

import {SolutionFileDoExerciseFullBase, SolutionDoExerciseFullBase} from "../../../../types/exerciseSolution";
import * as moment from "moment";
import {ActionBase, ActionType} from "../tutorViewSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {AfterSolutionDoExerciseFullBase} from '../../../../types/exerciseAfterSolution'

export type State = AfterSolutionDoExerciseFullBase


export const initial: State = {
  id: -1,
  pLangId: -1,
  userId: -1,
  releaseId: -1,
  mainFileId: -1,
  lastUpdatedAt: moment(),
  solutionFiles: [],
}


export interface SET_userAfterSolution_solutionFilesAction extends ActionBase {
  readonly type: ActionType.SET_userAfterSolution_solutionFiles
  readonly afterSolutionFiles: ReadonlyArray<SolutionFileDoExerciseFullBase>
}

export interface SET_userAfterSolution_mainFileIdAction extends ActionBase {
  readonly type: ActionType.SET_userAfterSolution_mainFileId
  readonly mainFileId: number
}


export type AllActions =
  SET_userAfterSolution_solutionFilesAction
  | SET_userAfterSolution_mainFileIdAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.SET_userAfterSolution_solutionFiles:
      return {
        ...state,
        solutionFiles: action.afterSolutionFiles
      }

    case ActionType.SET_userAfterSolution_mainFileId:
      return {
        ...state,
        mainFileId: action.mainFileId
      }

    default:
      //only working for > 1 types
      notExhaustive(action)
      return state
  }
}

