/**
 * Created by janis dähne.
 */

import {applyMiddleware, createStore} from 'redux';
import promise from 'redux-promise-middleware'
//import { PENDING, FULFILLED, REJECTED } from 'redux-promise-middleware' // see https://github.com/pburtchaell/redux-promise-middleware/blob/master/docs/introduction.md
import thunk from 'redux-thunk'
import {createLogger} from "redux-logger";

import reducers from './reducers/index'
import {ActionType} from "./reducers/loginReducer";
import {isProduction} from "../../debug";
import {ActionType as SettingsActionTypes} from './reducers/settingsSite/settingsSiteActionTypes'

const logger = createLogger({
  predicate: (getState, action) =>
    action.type !== ActionType.SET_PASSWORD
    && action.type !== ActionType.SET_registerPw
    && action.type !== ActionType.SET_registerPwAgain
    && action.type !== SettingsActionTypes.SET_oldPasswordCopy
    && action.type !== SettingsActionTypes.SET_newPasswordCopy
    && action.type !== SettingsActionTypes.SET_newPasswordCheckCopy
})

const middleware = isProduction ? applyMiddleware(promise(), thunk) : applyMiddleware(promise(), thunk, logger)

export default createStore(reducers, middleware)


