/**
 * Created by janis dähne.
 */


/**
 * fields can be -1 on error...
 */
export interface HardwareUsageStatistic {
  readonly totalRamInKb: number
  readonly freeRamInKb: number
  readonly cpuUsageInPercentage: number
}

export interface HardwareUsageStatisticFrontendExclusive extends HardwareUsageStatistic {
  /**
   * the time to display because we get every x seconds new data
   */
  readonly time: string
}


export interface LogicalUsageStatistic {
  readonly totalActivatedUsers: number

  readonly totalNotActivatedUsers: number
  /**
   * just an approximation
   */
  readonly totalOnlineUsers: number
  readonly totalSystemRoles: number
  readonly totalGroupRoles: number
  readonly totalExercises: number
  readonly totalCustomProjects: number

  readonly totalSubmissions: number
  readonly totalReleases: number
  readonly totalTags: number

  readonly runningAssessments: number
}


export interface TestServerPrivateSettings {

  readonly workingDirFullPath: string

  readonly hardTimeoutInMs: number
  readonly hardCompileTimeoutInMs: number
  readonly hardMemoryLimitInKb: number
  readonly hardDiskSpaceLimitInKb: number

  readonly maxParallelTests: number
  readonly maxNumberOfTestsWithOneRequest: number
  readonly maxLinesToRead: number
  readonly maxErrLinesToRead: number
  readonly maxLinesToWrite: number

  readonly dbServer: string
  readonly dbName: string

  readonly useConfigFromDb: boolean
  readonly dbConfigServer: string
  readonly dbConfigName: string
}

/**
 * the server constants are fixed after compiling
 * see backend class Constants for docs
 */
export interface ClientServerConstants {
  readonly versionString: string
  readonly port: number
  readonly breakAutoAssessmentAfterFirstError: boolean
  readonly testProtocolSplitString: string
  readonly testProtocolArgsString: string
  readonly apiPrefix: string
  readonly authTokenCookieName: string
  readonly cSRFCookieName: string
  readonly cSRFReturnHeaderName: string
}

/**
 * the app settings are fixed after app start)
 * see backend class AppConfiguration for docs
 */
export interface ClientServerAppSettings {
  readonly IsDebugMode: boolean
  readonly DbConnectionString: string
  readonly IsSlave: boolean
  readonly TokenTimeoutInS: number
  readonly MainEntrySite: string
  readonly LoginExternalFirstTimeSite: string
  readonly ExternalLoginUrl: string
  readonly DashboardScriptPathRelativeToCurrentDir: string
  readonly RunAssessmentsAsync: boolean
  readonly DebugOriginUrl: string
}


//also
//@see SystemSettingsBase
