/**
 * Created by janis dähne.
 */


/**
 * a programming language
 * frontend and backend type is equal (fullBase)
 */
export interface PLangFullBase {
  readonly id: number
  /**
   * the name of the programming language
   */
  readonly displayName: string
  /**
   * the internal name e.g. used for the online-editor
   * we use the file extension for syntax highlighting
   */
  readonly internalName: string | null

  /**
   * a comma separated list of file extensions for this plang
   */
  readonly fileExtensionsWithDot: string | null
  /**
   * the highlight mode for the editor (currently ace)
   * {@link possibleMarkdownHighlightPLanguages} for all possible langs
   *
   * for markdown
   * {@link possibleMarkdownHighlightPLanguages} but this is not needed because from the ```[lang] we directly dynamic import the lang
   */
  readonly editorHighlightModeName: string | null

}


export interface PLangWithExtrasFromBackend extends PLangFullBase {
  /**
   * true: plang can be deleted without any doubts (without deleting other data)
   * this is true if we have 0 releases with this plang AND there are no code templates for this plang
   * false: deleting plang would cascade and delete other data
   */
  readonly canBeDeleted: boolean

  /**
   * the reason why the plang cannot be deleted
   * can be null if CanBeDeleted is true
   */
  readonly cannotBeDeletedReason: string | null
}
